const $ = jQuery;

class InputValidation {
    constructor() {
        this.inputs = $("form .ysd-mapi-field input");
        this.addEvents();
    }

    addEvents() {
        this.inputs.on("focusout", (e) => {
            this.validateInput(e);
        });
    }

    validateInput(event) {

        // Translations
        const {
            errorI18n,
            siteURL,
        } = dashboardI18n;

        var elem = $(event.target);

        $.ajax({
            url: siteURL + '/wp-json/ysd-mapi/v1/input-validation/' + elem.attr('id'),
            data: {
                value: elem.val(),
            },
            error: function () {
                console.log('<p>' + errorI18n + '</p>');
            },
            success: function (data) {
                //@todo add feedback message to html
                if (!data.valid) {
                    elem.addClass("invalid");
                } else {
                    if (elem.hasClass("invalid")) {
                        elem.removeClass("invalid");
                    }
                }
            },
            type: 'GET'
        });
    }
}

export default InputValidation;