class Interval {
    constructor() {
        this.selectBoxes = document.querySelectorAll('.ysd-mapi-interval-select');
        this.addEvents();
        this.showInputsForAllBoxes();

    }

    addEvents() {
        for (let i = 0; i < this.selectBoxes.length; i++) {
            this.selectBoxes[i].addEventListener('change', (e) => {
                this.showInputs(e.target);
            });
        }

    }

    clearIntervalFields(element) {
        if ("undefined" === element) {
            element = document;
        }

        let field_containers = element.querySelectorAll(".ysd-mapi-interval-fields > div");

        for (let i = 0; i < field_containers.length; i++) {
            field_containers[i].style.display = "none";

            let inputs = field_containers[i].querySelectorAll("input");

            for (let x = 0; x < inputs; x++) {
                inputs[x].disabled = true;
            }
        }

    }

    showInputs(selectBox) {
        if (selectBox.value) {
            let parent = selectBox.parentElement.parentElement;
            let field_container = parent.querySelector(".ysd-mapi-interval-fields > ." + selectBox.value);
            let inputs = field_container.querySelectorAll("input");

            this.clearIntervalFields(parent);
            field_container.style.display = "grid";

            if (inputs !== "undefined") {
                for (let i = 0; i < inputs.length; i++) {
                    inputs[i].disabled = false;
                }
            }
        }

    }

    showInputsForAllBoxes() {
        for (let i = 0; i < this.selectBoxes.length; i++) {
            this.showInputs(this.selectBoxes[i]);
        }

    }

}

export default Interval;