class TabbedMetaBox {
    constructor() {
        this.tabs = document.querySelectorAll('.ysd-mapi-tab-section > ul > li');
        this.content = document.querySelector('.ysd-mapi-fields-section > div');
        this.activateFirst();
        this.addEvents();

    }

    addEvents() {
        for (let i = 0; i < this.tabs.length; i++) {
            this.tabs[i].addEventListener('click', (e) => {
                this.switchTab(e);
            });
        }

    }

    activateFirst() {
        if (this.tabs.length > 0) {
            this.tabs[0].classList.add('active');
            this.content.classList.add('active');
        }

    }

    switchTab(event) {
        let target = event.target;
        let newContent = document.querySelector('#' + target.getAttribute('data-field-group'));

        if(newContent)
        {
            let currentActiveTab = document.querySelector('.ysd-mapi-tab-section > ul > li.active');
            let currentActiveContent = document.querySelector('#' + currentActiveTab.getAttribute('data-field-group'));

            currentActiveTab.classList.remove('active');
            currentActiveContent.classList.remove('active');

            target.classList.add('active');
            newContent.classList.add('active');
        }

    }
}

export default TabbedMetaBox;