const $ = jQuery;
const self = this;

import SyncProgression from "./modules/SyncProgression.js";
import UpdateHistory from "./modules/UpdateHistory.js";

// Instantiate a new object using our modules / classes
let syncProgression = new SyncProgression();
let updateHistory = new UpdateHistory(document.querySelector('.c-update-history__right'), document.querySelector('.c-update-history .ysd-mapi-tab-section'));

syncProgression.startInterval();

$('[data-field-group="update-history"]').click(function () {
    if (!$(this).hasClass('clicked')) {
        updateHistory.displayHistoryMenu();
        $(this).addClass('clicked');
    }
});

$('.ysd-mapi-tab-section > ul > li').click(function () {
    if ($(this).data("field-group") === "businessSettings") {
        $('#submit').attr('form', 'mapBusiness');
    } else {
        $('#submit').removeAttr('form');
    }

});

$('.c-update-history__left').on('click', '.ysd-mapi__logs-nav-item', function () {
    let element = this;

    $('.ysd-mapi__logs-nav-item').removeClass('active');
    element.classList.add('active');

    displayHistory();
});

function displayHistory() {
    let element = document.querySelector('.ysd-mapi__logs-nav-item.active');

    if (element) {
        let year = element.getAttribute('data-logs-date-year');
        let month = element.getAttribute('data-logs-date-month');

        updateHistory.displayHistory(year, month);
    }

}