<?php

$validator = '\ysdmapi\includes\custom_fields\FieldValidator';

$archive_string = __( 'Archive | ', YSD_MAPI_TEXT_DOMAIN );
$single_string  = __( 'Single | ', YSD_MAPI_TEXT_DOMAIN );

$mapiPF = $mapiPF_nl = $mapiPF_en = $mapiPF_df = '';
if ( class_exists( 'Mapi_Property_Filters' ) ) {
    $mapiPF    = new Mapi_Property_Filters();
    $mapiPF_nl = json_encode( $mapiPF->get_filter( 'NL' ), JSON_PRETTY_PRINT );
    $mapiPF_en = json_encode( $mapiPF->get_filter( 'EN' ), JSON_PRETTY_PRINT );
    // $mapiPF_df = json_encode( $mapiPF->property_filters_default(), JSON_PRETTY_PRINT );
}

$get_list_pages = array_merge(
    YSD_Mapi_Helpers::generate_post_list( 'page', false, true )
);

return
[
    'apiSettings' =>
    [
        'label' => __( 'API', YSD_MAPI_TEXT_DOMAIN),
        'fields' =>
        [
            'sync_data' =>
            [
                'label' => __( 'Synchronize Data', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'switch-button',
                'description' => __( 'Switch on to start synchronizing data from the API', YSD_MAPI_TEXT_DOMAIN ),
            ],
            'api_handler_url' =>
            [
                'label' => __( 'MAPI API Handler', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'select',
                'default_value' => 0,
                'options' => array(
                    0 => 'MAPI',
                    1 => 'ReVa',
                ),
            ],
            'mapi_token' =>
            [
                'label' => __( 'MAPI Token', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'text',
            ],
            'api_author' =>
            [
                'label' => __( 'MAPI Author', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'user-selection',
                'description' => __( 'The account that will be associated with the imported properties', YSD_MAPI_TEXT_DOMAIN ),
            ],
            'sync_schedule' =>
            [
                'label' => __( 'Synchronization schedule', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'interval',
                'options' =>
                [
                    'daily' => __( 'Daily', YSD_MAPI_TEXT_DOMAIN),
                    'hourly' => __( 'Hourly', YSD_MAPI_TEXT_DOMAIN),
                ],
            ],
            'load_images' =>
            [
                'label' => __( 'Load Property Images', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'load_videos' =>
            [
                'label' => __( 'Load Property Videos', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'switch-button',
            ],
            'load_floorplans' =>
            [
                'label' => __( 'Load Property Floorplans', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            // 'load_brochures' =>
            // [
            //     'label' => __( 'Load Property Brochures', YSD_MAPI_TEXT_DOMAIN),
            //     'type' => 'switch-button',
            // ],
            // 'load_maps' =>
            // [
            //     'label' => __( 'Load Property Google Maps', YSD_MAPI_TEXT_DOMAIN),
            //     'type' => 'switch-button',
            // ],
            'show_in_library' =>
            [
                'label' => __( 'Show Media In Library', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'switch-button',
            ],
        ],
    ],
    'generalSettings' =>
    [
        'label' => __( 'General', YSD_MAPI_TEXT_DOMAIN),
        'fields' => 
        [
            'realtor_phone_number' =>
            [
                'label' => __( 'Phone number', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'text',
                'attributes' => [
                    'placeholder' => '+31 (0)71 203 20 89',
                ],
            ],
            'realtor_phone_number_link' =>
            [
                'label' => __( 'Phone number link', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'text',
                'attributes' => [
                    'placeholder' => '+31712032089',
                ],
            ],
            'realtor_email_address' =>
            [
                'label' => __( 'Email address', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'text',
                'attributes' => [
                    'placeholder' => 'info@your-style.nl',
                ],
            ],
            'realtor_property_valuta' =>
            [
                'label' => __( 'Valuta', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'select',
                'default_value' => 'EUR',
                'options' => array(
                    'EUR' => __( 'Euro', YSD_MAPI_TEXT_DOMAIN ),
                    'GBP' => __( 'British Pound', YSD_MAPI_TEXT_DOMAIN ),
                    'USD' => __( 'US Dollar', YSD_MAPI_TEXT_DOMAIN ),
                ),
            ],
            'realtor_property_unit' =>
            [
                'label' => __( 'Measurement unit', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'select',
                'default_value' => 'metric',
                'options' => array(
                    'metric' => __( 'Metric', YSD_MAPI_TEXT_DOMAIN),
                    'imperial' => __( 'Imperial', YSD_MAPI_TEXT_DOMAIN),
                ),
            ],
        ],
    ],
    'layoutSettings' =>
    [
        'label' => __( 'Layout', YSD_MAPI_TEXT_DOMAIN),
        'fields' =>
        [
            'archive_properties_per_row' =>
            [
                'label' => $archive_string . __( 'Properties per row', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'select',
                'default_value' => 2,
                'options' => array(
                    1 => '1',
                    2 => '2',
                    3 => '3',
                    4 => '4',
                    5 => '5',
                    6 => '6',
                ),
            ],
            'archive_properties_per_page' =>
            [
                'label' => $archive_string . __( 'Properties per page', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'number',
                'default_value' => '10',
            ],
            'archive_per_page_options' =>
            [
                'label' => $archive_string . __( 'Per page options', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => '10,20,40,80',
            ],
            'archive_properties_ordering' =>
            [
                'label' => $archive_string . __( 'Properties ordering', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'select',
                'default_value' => 'date:desc',
                'options' => array(
                    'date:desc' => __( 'Date (descending)', YSD_MAPI_TEXT_DOMAIN ),
                    'date:asc' => __( 'Date (ascending)', YSD_MAPI_TEXT_DOMAIN ),
                    'sale_status:desc' => __( 'Status (descending)', YSD_MAPI_TEXT_DOMAIN ),
                    'sale_status:asc' => __( 'Status (ascending)', YSD_MAPI_TEXT_DOMAIN ),
                    'price:desc' => __( 'Price (descending)', YSD_MAPI_TEXT_DOMAIN ),
                    'price:asc' => __( 'Price (ascending)', YSD_MAPI_TEXT_DOMAIN ),
                ),
            ],
            'archive_properties_layout' =>
            [
                'label' => $archive_string . __( 'Properties layout', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'select',
                'default_value' => 'grid',
                'options' => array(
                    'grid' => __( 'Grid', YSD_MAPI_TEXT_DOMAIN ),
                    'list' => __( 'List', YSD_MAPI_TEXT_DOMAIN ),
                ),
            ],
            'archive_map' =>
            [
                'label' => $archive_string . __( 'Display map layout', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => false,
            ],
            'archive_display_title' =>
            [
                'label' => $archive_string . __( 'Display archive title', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'archive_header' =>
            [
                'label' => $archive_string . __( 'Display archive header', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'archive_sidebar_widget_area' =>
            [
                'label' => $archive_string . __( 'Display sidebar widget area', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'archive_filter' =>
            [
                'label' => $archive_string . __( 'Display filter', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'archive_filter_auto_submit' =>
            [
                'label' => $archive_string . __( 'Auto submit filter', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'archive_footer' =>
            [
                'label' => $archive_string . __( 'Display footer', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'single_show_header' =>
            [
                'label' => $single_string . __( 'Show header', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'single_show_gallery' =>
            [
                'label' => $single_string . __( 'Show gallery', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'single_show_status' =>
            [
                'label' => $single_string . __( 'Show status', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'single_show_desc' =>
            [
                'label' => $single_string . __( 'Show description', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'single_desc_btn_class' =>
            [
                'label' => $single_string . __( 'Read more/less button class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'c-button c-button--color-1 c-button--sm',
                'condition' => 
                [
                    'field' => 'single_show_desc',
                    'value' => 'true',
                    'compare' => '=',
                ],
            ],
            'single_show_data' =>
            [
                'label' => $single_string . __( 'Show data', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'single_show_map' =>
            [
                'label' => $single_string . __( 'Show map', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'single_sidebar_widget_area' =>
            [
                'label' => $single_string . __( 'Display sidebar widget area', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'single_contact_widget' =>
            [
                'label' => $single_string . __( 'Show contact', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
            ],
            'single_contact_widget_action[type]' =>
            [
                'label' => $single_string . __( 'Contact widget action', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'select',
                'default_value' => 'hide',
                'options' => [
                    'hide' => __( 'Hide Button', YSD_MAPI_TEXT_DOMAIN ),
                    'modal' => __( 'Modal', YSD_MAPI_TEXT_DOMAIN ),
                    'page' => __( 'Page', YSD_MAPI_TEXT_DOMAIN ),
                ],
            ],
            'single_contact_widget_btn_class' =>
            [
                'label' => $single_string . __( 'Contact widget button class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'c-button c-button--color-1 c-button--round',
                'condition' => 
                [
                    'field' => 'single_contact_widget_action[type]',
                    'value' => 'hide',
                    'compare' => '!',
                ],
            ],
            'single_contact_widget_action[content]' =>
            [
                'label' => $single_string . __( 'Contact widget: modal content', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'condition' => 
                [
                    'field' => 'single_contact_widget_action[type]',
                    'value' => 'modal',
                    'compare' => '=',
                ],
                'attributes' => [
                    'placeholder' => __( 'e.g.', YSD_MAPI_TEXT_DOMAIN ) . ' [gravityform id="1"]',
                ],
            ],
            'single_contact_widget_action_submit_class' =>
            [
                'label' => $single_string . __( 'Contact widget: modal submit class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'c-button c-button--color-1 c-button--round',
                'condition' => 
                [
                    'field' => 'single_contact_widget_action[type]',
                    'value' => 'modal',
                    'compare' => '=',
                ],
            ],
            'single_contact_widget_action[page]' =>
            [
                'label' => $single_string . __( 'Contact widget: page link', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'condition' => 
                [
                    'field' => 'single_contact_widget_action[type]',
                    'value' => 'page',
                    'compare' => '=',
                ],
                'attributes' => [
                    'placeholder' => __( 'e.g.', YSD_MAPI_TEXT_DOMAIN ) . ' https://example.com/contact',
                ],
            ],
            'single_contact_widget_action[page_target]' =>
            [
                'label' => $single_string . __( 'Contact widget: page link target', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'select',
                'default_value' => '_blank',
                'options' => array(
                    '_self' => __( 'Same tab', YSD_MAPI_TEXT_DOMAIN ),
                    '_blank' => __( 'New tab', YSD_MAPI_TEXT_DOMAIN ),
                ),
                'condition' => 
                [
                    'field' => 'single_contact_widget_action[type]',
                    'value' => 'page',
                    'compare' => '=',
                ],
            ],
            'single_show_footer' =>
            [
                'label' => $single_string . __( 'Show footer', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'switch-button',
                'default_value' => true,
            ],
        ],
    ],
    'advancedSettings' =>
    [
        'label' => __( 'Advanced', YSD_MAPI_TEXT_DOMAIN),
        'fields' =>
        [
            'archive_rewrite_slug' =>
            [
                'label' => $archive_string . __( 'Slug', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => __( 'property', YSD_MAPI_TEXT_DOMAIN ),
            ],
            'archive_template' =>
            [
                'label' => $archive_string . __( 'Template', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'select',
                'default_value' => 'sidebar',
                'options' => array(
                    'normal' => __( 'Normal', YSD_MAPI_TEXT_DOMAIN ),
                    'full_width' => __( 'Full width', YSD_MAPI_TEXT_DOMAIN ),
                    'sidebar' => __( 'Sidebar', YSD_MAPI_TEXT_DOMAIN ),
                ),
            ],
            'archive_holder_class' =>
            [
                'label' => $archive_string . __( 'Wrapper class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'u-padding-vertical-xl u-background-color-gray-1',
            ],
            'archive_row_class' =>
            [
                'label' => $archive_string . __( 'Row class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'u-flex-row-reverse',
            ],
            'archive_main_columns' =>
            [
                'label' => $archive_string . __( 'Content column class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'c-col-12 c-col-lg-9',
            ],
            'archive_aside_columns' =>
            [
                'label' => $archive_string . __( 'Sidebar column class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'c-col-lg-3',
            ],
            'buy_template' =>
            [
                'label' => $archive_string . __( 'Buy page', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'select',
                'default_value' => '',
                'optionsInvert' => true,
                'options' => $get_list_pages,
            ],
            'rent_template' =>
            [
                'label' => $archive_string . __( 'Rent page', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'select',
                'default_value' => '',
                'optionsInvert' => true,
                'options' => $get_list_pages,
            ],
            'single_rewrite_slug' =>
            [
                'label' => $single_string . __( 'Slug', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => __( 'property', YSD_MAPI_TEXT_DOMAIN ),
            ],
            'single_url_structure' =>
            [
                'label' => $single_string . __( 'URL Structure', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'select',
                'default_value' => 'plain',
                'options' => array(
                    'plain' => __( 'Plain', YSD_MAPI_TEXT_DOMAIN ),
                    'pretty' => __( 'Pretty', YSD_MAPI_TEXT_DOMAIN ),
                ),
            ],
            'single_holder_class' =>
            [
                'label' => $single_string . __( 'Wrapper class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'u-padding-vertical-xl',
            ],
            'single_main_columns' =>
            [
                'label' => $single_string . __( 'Content column class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'c-col-12 c-col-md-7 c-col-lg-8',
            ],
            'single_aside_columns' =>
            [
                'label' => $single_string . __( 'Sidebar column class', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => 'c-col-12 c-col-md-5 c-col-lg-4',
            ],
            'single_template_hooks' =>
            [
                'label' => $single_string . __( 'Template hooks', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'select',
                'default_value' => 'enabled',
                'options' => array(
                    'enabled' => __( 'Enabled', YSD_MAPI_TEXT_DOMAIN ),
                    'disabled' => __( 'Disabled', YSD_MAPI_TEXT_DOMAIN ),
                ),
            ],
            'single_alt_content' =>
            [
                'label' => $single_string . __( 'Templatera Shortcode', YSD_MAPI_TEXT_DOMAIN ),
                'type' => 'text',
                'default_value' => '[templatera id="#"]',
                'condition' => 
                [
                    'field' => 'single_template_hooks',
                    'value' => 'disabled',
                    'compare' => '=',
                ],
            ],
            'load_fancybox' =>
            [
                'label' => $single_string . __( 'Load FancyBox', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'select',
                'default_value' => 'enabled',
                'options' => array(
                    'enabled' => __( 'Enabled', YSD_MAPI_TEXT_DOMAIN ),
                    'disabled' => __( 'Disabled', YSD_MAPI_TEXT_DOMAIN ),
                ),
            ],
            'debug_mode' =>
            [
                'label' => __( 'Debug Mode (Developers Only)', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'select',
                'default_value' => 'disabled',
                'options' => array(
                    'disabled' => __( 'Disabled', YSD_MAPI_TEXT_DOMAIN ),
                    'enabled' => __( 'Enabled', YSD_MAPI_TEXT_DOMAIN ),
                ),
            ],
        ]
    ],
    'filterSettings' =>
    [
        'label' => __( 'Filter', YSD_MAPI_TEXT_DOMAIN),
        'fields' =>
        [
            'archive_display_filter_toggle' =>
            [
                'label' => __( 'Display filter toggle', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'archive_display_filter_result_count' =>
            [
                'label' => __( 'Display filter result count', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'switch-button',
                'default_value' => true,
            ],
            'archive_filter_submit_class' =>
            [
                'label' => __( 'Filter submit class', YSD_MAPI_TEXT_DOMAIN),
                'type' => 'text',
                'default_value' => 'c-button c-button--color-1',
            ],
        ],
    ],
    'filterJSON' =>
    [
        'label' => __( 'Filter JSON', YSD_MAPI_TEXT_DOMAIN),
        'fields' =>
        [
            'filters_NL' =>
            [
                'label' => 'Nederlands',
                'type' => 'textarea',
                'value' => $mapiPF_nl,
            ],
            'filters_EN' =>
            [
                'label' => 'English',
                'type' => 'textarea',
                'value' => $mapiPF_en,
            ],
            'filters_default' =>
            [
                'label' => '',
                'type' => 'textarea',
                'value' => $mapiPF_nl,
            ],
        ],
    ],
];