<?php

$validator = '\ysdmapi\includes\custom_fields\FieldValidator';

return 
[
    'general' => 
    [
        'label' => 'General',
        'fields' => 
        [
            'address_1' =>
            [
                'label' => 'Street name',
                'type' => 'text',
            ],
            'house_number' =>
            [
                'label' => 'House number + addition',
                'type' => 'text',
            ],
            'zipcode' =>
            [
                'label' => 'Zipcode',
                'type' => 'text',
                'validation' => [$validator, 'validate_dutch_zipcode'],
            ],
            'city' =>
            [
                'label' => 'City',
                'type' => 'text',
                'validation' => [$validator, 'validate_city'],
            ],
            'country' =>
            [
                'label' => 'Country',
                'type' => 'text',
            ],
            'commune' =>
            [
                'label' => 'Commune',
                'type' => 'text',
            ],
            'province' =>
            [
                'label' => 'Province',
                'type' => 'text',
            ],
        ],
    ],

    'media' =>
    [
        'label' => 'Media',
        'fields' =>
        [
            'pictures' =>
            [
                'label' => 'Pictures',
                'type' => 'images',
            ],
            'floorplan' =>
            [
                'label' => 'Floorplans',
                'type' => 'floorplans',
            ],
            'videos' =>
            [
                'label' => 'Videos',
                'type' => 'videos',
            ],
            'video_url' =>
            [
                'label' => 'Video URL',
                'type' => 'video-url',
            ],
            'brochures' =>
            [
                'label' => 'Brochures',
                'type' => 'brochures',
            ],
            'brochure_url' =>
            [
                'label' => 'Brochure URL',
                'type' => 'brochure-url',
            ],
        ],
    ],

    'transfer' =>
    [
        'label' => 'Transfer',
        'fields' =>
        [
            'price' =>
            [
                'label' => 'Price',
                'type' => 'number',
            ],
            'price_type' =>
            [
                'label' => 'Price type',
                'type' => 'select',
                'options' => [
                    'vraagprijs' => 'Asking price',
                    'huurprijs' => 'Rent price',
                    'koopsom' => 'Purchase price',
                ],
            ],
            'sale_type' =>
            [
                'label' => 'Sale type',
                'type' => 'select',
                'options' =>
                [
                    '1' => 'Buy', 
                    '2' => 'Rent',
                ],
            ],
            'sale_status' =>
            [
                'label' => 'Status',
                'type' => 'select',
                'options' =>
                [
                    '1' => 'For sale',
                    '2' => 'For rent',
                    '3' => 'Under offer',
                    '4' => 'Sold STC',
                    '5' => 'Rented STC',
                    '6' => 'Sold',
                    '7' => 'Rented',
                    '8' => 'Purchased',
                    '9' => 'Withdrawn',
                ],
            ],
            'sale_condition' =>
            [
                'label' => 'Sale condition',
                'type' => 'select',
                'options' =>
                [
                    '1' => 'k.k.',
                    '2' => 'v.o.n.',
                    '3' => 'per month',
                    '4' => 'quarterly',
                    '5' => 'per half year',
                    '6' => 'per year',
                    '7' => 'per contract',
                    '8' => 'per m² per month',
                    '9' => 'per m² per year',
                ],
            ],
            'listed_since' => 
            [
                'label' => 'Listed since',
                'type' => 'date',
            ],
            'sold_since' =>
            [
                'label' => 'Sold since',
                'type' => 'date',
            ],
            'sold_or_rented_at' =>
            [
                'label' => 'Sold or rented at',
                'type' => 'datetime-local',
            ],
            'object_code' =>
            [
                'label' => 'Object ID',
                'type' => 'text',
            ],
            'created_at' =>
            [
                'label' => 'Created at',
                'type' => 'datetime-local',
            ],
            'updated_at' =>
            [
                'label' => 'Updated at',
                'type' => 'datetime-local',
            ],
            'acceptance' => 
            [
                'label' => 'Acceptance',
                'type' => 'select',
                'options' => 
                [
                    '1' => 'Direct',
                    '2' => 'Per date',
                    '3' => 'in consultation',
                ],
            ],
            'acceptance_explanation' =>
            [
                'label' => 'Acceptance explanation',
                'type' => 'text',
            ],
            'acceptance_date' => 
            [
                'label' => 'Acceptance date',
                'type' => 'date',
            ],
        ],
    ],

    'construction' => 
    [
        'label' => 'Construction',
        'fields' => 
        [
            'og' =>
            [
                'label' => 'Object type',
                'type' => 'select',
                'options' =>
                [
                    'WONEN' => 'Housing real estate',
			        'BOG' => 'Business real estate',
			        'HUUR' => 'Rent real estate',
                ],
            ],
            'year_built' =>
            [
                'label' => 'Year of construction',
                'type' => 'number',
            ],
            'build_type' =>
            [
                'label' => 'Building type',
                'type' => 'select',
                'options' =>
                [
                    'Nieuwbouw' => 'New construction',
                    'Bestaande bouw' => 'Existing construction',
                    'Niet van toepassing' => 'Not applicable',
                ],
            ],
            'year_built_period' =>
            [
                'label' => 'Construction period',
                'type' => 'text',
            ],
            'under_construction' =>
            [
                'label' => 'Under construction',
                'type' => 'select',
                'options' => 
                [
                    false => 'No',
                    true => 'Yes',
                ],
            ],
        ],
    ],

    'size' =>
    [
        'label' => 'Size',
        'fields' =>
        [
            'type' =>
            [
                'label' => 'Offer type',
                'type' => 'select',
                'options' =>
                [
                    '1' => 'House',
                    '2' => 'Apartment',
                    '3' => 'Parking spot',
                    '4' => 'Building plot',
                    '5' => 'Office space',
                    '6' => 'Business hall',
                    '7' => 'Other private houses',
                    '8' => 'Other BOG properties',
                    '9' => 'Other properties',
                ],
            ],
            'volume_area' =>
            [
                'label' => 'Volume area',
                'type' => 'number',
            ],
            'usable_area' =>
            [
                'label' => 'Usable area',
                'type' => 'number',
            ],
            'plot_area' =>
            [
                'label' => 'Plot area',
                'type' => 'number',
            ],
            'is_furnished' =>
            [
                'label' => 'Furnished',
                'type' => 'select',
                'options' =>
                [
                    '0' => 'No',
			        '1' => 'Yes',
                ],
            ],
            'is_upholstered' =>
            [
                'label' => 'Upholstered',
                'type' => 'select',
                'options' =>
                [
                    '0' =>'No',
			        '1' => 'Yes',
                ],
            ],
        ],
    ],

    'layout' =>
    [
        'label' => 'Layout',
        'fields' =>
        [
            'number_of_rooms' =>
            [
                'label' => 'Number of rooms',
                'type' => 'number',
            ],
            'number_of_bedrooms' =>
            [
                'label' => 'Number of bedrooms',
                'type' => 'number',
            ],
            'number_of_bathrooms' =>
            [
                'label' => 'Number of bathrooms',
                'type' => 'number',
            ],
            'number_of_stories' =>
            [
                'label' => 'Number of stories',
                'type' => 'number',
            ],
            'number_of_floors' => 
            [
                'label' => 'Number of floors',
                'type' => 'number',
            ],
            'facilities' =>
            [
                'label' => 'Facilities',
                'type' => 'text',
            ],
        ],
    ],

    'energy' =>
    [
        'label' => 'Energy',
        'fields' =>
        [
            'energy_label' =>
            [
                'label' => 'Energy class',
                'type' => 'select',
                'options' =>
                [
                    '' => 'Not available',
                    'A' => 'A',
					'A_P' => 'A+',
					'A_PP' => 'A++',
					'A_PPP' => 'A+++',
					'A_PPPP' => 'A++++',
					'A_PPPPP' => 'A+++++',
                    'B' => 'B',
                    'C' => 'C',
                    'D' => 'D',
                    'E' => 'E',
                    'F' => 'F',
                    'G' => 'G',
                ],
            ],
            'energy_index' =>
            [
                'label' => 'Energy index',
                'type' => 'number',
            ],
            'energy_label_end_date' =>
            [
                'label' => 'Energy label end date',
                'type' => 'date',
            ],
            'energy_insulation' =>
            [
                'label' => 'Insulation form',
                'type' => 'text',
            ],
            'energy_epc' =>
            [
                'label' => 'EPC',
                'type' => 'text',
            ],
            'energy_heating' => 
            [
                'label' => 'Types of heaters',
                'type' => 'text',
            ],
            'boiler_type' =>
            [
                'label' => 'Boiler type',
                'type' => 'text',
            ],
            'boiler_year' =>
            [
                'label' => 'Boiler year',
                'type' => 'number',
            ],
            'boiler_property' =>
            [
                'label' => 'Boiler property',
                'type' => 'text',
            ],
            'boiler_combi' =>
            [
                'label' => 'Boiler combi',
                'type' => 'switch-button',
            ],
        ],
    ],

    'exterior_space' =>
    [
        'label' => 'Exterior space',
        'fields' => 
        [
            'exterior_space_location' =>
            [
                'label' => 'Location',
                'type' => 'text',
            ],
            'exterior_space_types' => 
            [
                'label' => 'Front and backyard types',
                'type' => 'text',
            ],
            'exterior_space_area' => 
            [
                'label' => 'Backyard',
                'type' => 'text',
            ],
            'exterior_space_garden' => 
            [
                'label' => 'Backyard location',
                'type' => 'text',
            ],
        ],
    ],

    'garage' => 
    [
        'label' => 'Garage',
        'fields' =>
        [
            'garage_type' =>
            [
                'label' => 'Garage type',
                'type' => 'text',
            ],
            'garage_capacity' =>
            [
                'label' => 'Garage capacity',
                'type' => 'text',
            ],
            'garage_area' => 
            [
                'label' => 'Garage area',
                'type' => 'number',
            ],
        ],
    ],

    'settings' =>
    [
        'label' => 'Settings',
        'fields' =>
        [
            'accountmanager' => [
                'label' => 'Accountmanager ID',
                'type' => 'number',
            ],
            'featured_property' =>
            [
                'label' => 'Featured Property',
                'type' => 'switch-button',
            ],
            'sync_api' =>
            [
                'label' => 'Synchronize data',
                'type' => 'switch-button',
            ],
        ],
    ],

];