<?php
    // @todo: Make a function of this!
    global $plugin_page;
    $fields = $this->field_handler->get_page_fields();

    // Accountmanager Args
    $accs_args = [ 
        'post_type' => 'property',
        'posts_per_page' => -1,
        'meta_query' => [
            [
                'key' => 'accountmanager',
                'compare' => 'EXISTS',
            ],
            [
                'key' => 'accountmanager',
                'value' => '',
                'compare' => '!=',
            ],
        ],
    ];

    $accs_query = new WP_Query($accs_args);
    $property_posts = $accs_query->get_posts();

    $accountmanagers = [];
    foreach($property_posts as $property_post) {
        $accountmanager = get_post_meta($property_post->ID, 'accountmanager', true);
        if(!in_array($accountmanager, $accountmanagers)) {
            $accountmanagers[$accountmanager] = $accountmanager;
        }
    }

    // Accountmanagers Posts
    $args1 = [
        'post_type' => 'employee',
        'posts_per_page' => -1,
    ];
    $query1 = new WP_Query($args1);
    $employees = $query1->get_posts();

    if(!empty($employees)){
        session_start();
        $value = $_SESSION['standard_employee']; 
    }

    // Agencies Args
    $ages_args = [ 
        'post_type' => 'property',
        'posts_per_page' => -1,
        'meta_query' => [
            [
                'key' => 'agency_id',
                'compare' => 'EXISTS',
            ],
            [
                'key' => 'agency_id',
                'value' => '',
                'compare' => '!=',
            ],
        ],
    ];

    $ages_query = new WP_Query($ages_args);
    $agency_posts = $ages_query->get_posts();

    $agencies = [];
    foreach($agency_posts as $agency_post) {
        $agency = get_post_meta($agency_post->ID, 'agency_id', true);
        if(!in_array($agency, $agencies)) {
            $agencies[$agency] = $agency;
        }
    }

    // Agencies Posts
    $args2 = [
        'post_type' => 'office',
        'posts_per_page' => -1,
    ];
    $query2 = new WP_Query($args2);
    $offices = $query2->get_posts();

?>

<header class="mapi-header">
    <h1 class="mapi-title"><?php _e( 'MAPI - Thé Makelaars API', YSD_MAPI_TEXT_DOMAIN ); ?></h1>
    <p class="mapi-subtitle"><span><?php _e( 'by', YSD_MAPI_TEXT_DOMAIN ); ?></span> <a href="https://your-style.nl">yourstyle</a></p>
</header>

<?php
    // @todo: fix this
    // $userValidationCheck = UserValidation::check_validation();
    // if ($userValidationCheck == FALSE) {
    //     $user_validation = new UserValidation();
    //     $user_validation->cron_telemetry();
    //     echo '<div id="message" class="error" style="margin: 0 0 1.5rem;"><p>';
    //         echo $user_validation->validation_warning();
    //     echo '</p></div>';
    // }
?>

<div class="ysd-mapi-tab-section">
    <ul>
        <li data-field-group="dashboard" class="active"><?php _e( 'Dashboard', YSD_MAPI_TEXT_DOMAIN ); ?></li>
        
        <?php if(run_user_validation()) { ?>
            <?php foreach($fields['field_groups'] as $group) : ?>
                <li data-field-group="<?php echo $group->get_id(); ?>"><?php _e( $group->get_label(), YSD_MAPI_TEXT_DOMAIN ); ?></li>
            <?php endforeach ?>

            <?php if ( is_plugin_active( 'wps-employee/wps-employee.php' ) || is_plugin_active( 'ysp-business/ysp-business.php' ) ) : ?>
                <li data-field-group="businessSettings"><?php echo 'Business'; ?></li>
            <?php endif; ?>

            <li data-field-group="update-history"><div class="c-redo-history-icon"></div></li>
        <?php } ?>
    </ul>
</div>

<form class="ysd-mapi-options-section" action="options.php" method="post">

    <?php settings_fields( $plugin_page ); ?>
    <?php // $mapi_token = get_option( 'ysd-mapi_license_token' ); // @todo: fix this ?>
    <?php $mapi_token = 'aaa'; ?>
    
    <div class="ysd-mapi-fields-section">
        <!-- Dashboard tab -->
        <div id="dashboard" class="active">
            <div class="ysd-mapi-update-information">
                <div class="ysd-mapi__update-jobs">
                    <?php if(run_user_validation()) { ?>
                        <h2 class="title"><?php _e( 'Update information', YSD_MAPI_TEXT_DOMAIN ); ?></h2>
                        <table class="ysd-mapi__update-jobs__table">
                            <tbody>
                                <tr class="ysd-mapi-job__progress">
                                    <td class="ysd-mapi-job__progress-label"><?php _e( 'Progress', YSD_MAPI_TEXT_DOMAIN ); ?>:</td>
                                    <td class="ysd-mapi-job__progress-value">
                                        <div class="ysd-mapi-progress">
                                            <div class="ysd-mapi-progress__bar ysd-mapi-progress__bar--striped" role="progressbar" aria-valuenow="" aria-valuemin="0" aria-valuemax="100">
                                                <div class="ysd-mapi-progress__bar-label"></div>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr class="ysd-mapi-job__media">
                                    <td class="ysd-mapi-job__media-label"><?php _e( 'Media progress', YSD_MAPI_TEXT_DOMAIN ); ?>:</td>
                                    <td class="ysd-mapi-job__media-value">
                                        <div class="ysd-mapi-progress">
                                            <div class="ysd-mapi-progress__bar ysd-mapi-progress__bar--striped" role="progressbar" aria-valuenow="" aria-valuemin="0" aria-valuemax="100">
                                                <div class="ysd-mapi-progress__bar-label"></div>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr class="ysd-mapi-job__status">
                                    <td class="ysd-mapi-job__status-label"><?php _e( 'Current status', YSD_MAPI_TEXT_DOMAIN ); ?>:</td>
                                    <td class="ysd-mapi-job__status-value"></td>
                                </tr>
                                <tr class="ysd-mapi-job__schedule">
                                    <td class="ysd-mapi-job__schedule-label"><?php _e( 'Next scheduled at', YSD_MAPI_TEXT_DOMAIN ); ?>:</td>
                                    <td class="ysd-mapi-job__schedule-value"></td>
                                </tr>
                                <tr class="ysd-mapi-job__message">
                                    <td class="ysd-mapi-job__message-label"><?php _e( 'Latest message', YSD_MAPI_TEXT_DOMAIN ); ?>:</td>
                                    <td class="ysd-mapi-job__message-value"></td>
                                </tr>
                            </tbody>
                        </table>
                    <?php } ?>
                    <div class="ysd-mapi-general-information">
                        <h2 class="title"><?php _e( 'General information', YSD_MAPI_TEXT_DOMAIN ); ?></h2>
                        <table>
                            <tbody>
                                <tr>
                                    <td><strong><?php _e( 'MAPI version', YSD_MAPI_TEXT_DOMAIN ); ?></strong></td>
                                    <td><?php echo YSD_MAPI_VERSION . ' (beta)'; ?></td>
                                </tr>
                                <?php
                                    $newVersion = 0;
                                    if ( ! empty( get_site_transient( 'update_plugins' )->response['ysd-mapi/ysd-mapi.php']->new_version ) ) {
                                        $newVersion = get_site_transient( 'update_plugins' )->response['ysd-mapi/ysd-mapi.php']->new_version;
                                    }
                                    $currentVersion = YSD_MAPI_VERSION;
                                ?>
                                <?php if ( $newVersion ) { ?>
                                    <tr>
                                        <td><strong><?php _e( 'New version', YSD_MAPI_TEXT_DOMAIN ); ?></strong></td>
                                        <td>
                                            <?php echo $newVersion . ' (beta)'; ?>
                                            <a href="<?php echo esc_attr( admin_url( 'plugins.php?s=Mapi' ) ); ?>"><?php _e( 'Update now', YSD_MAPI_TEXT_DOMAIN ); ?></a>
                                        </td>
                                    </tr>
                                <?php } ?>
                                <tr>
                                    <td><strong><?php _e( 'PHP version', YSD_MAPI_TEXT_DOMAIN ); ?></strong></td>
                                    <td><?php echo phpversion(); ?></td>
                                </tr>
                                <tr>
                                    <td><strong><?php _e( 'PHP Max Execution Time', YSD_MAPI_TEXT_DOMAIN ); ?></strong></td>
                                    <td><?php echo ini_get('max_execution_time'); ?></td>
                                </tr>
                                <tr>
                                    <td><strong><?php _e( 'PHP Memory Limit', YSD_MAPI_TEXT_DOMAIN ); ?></strong></td>
                                    <td><?php echo ini_get('memory_limit'); ?></td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <?php if(empty($mapi_token)) { ?>
                        <div class="ysd-mapi-license-information">
                            <h2 class="title"><?php _e( 'License information', YSD_MAPI_TEXT_DOMAIN ); ?></h2>
                            <table class="ysd-mapi__update-license">
                                <tbody>
                                    <tr>
                                        <td><strong><?php _e( 'MAPI token', YSD_MAPI_TEXT_DOMAIN ); ?></strong></td>
                                        <td><input type="text" id="ysd-mapi_license_token" name="ysd-mapi_license_token" value="<?php echo $mapi_token; ?>"></td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    <?php } ?>
                </div>
                <?php if(run_user_validation()) { ?>
                    <div class="ysd-mapi__update-logs">
                        <h2 class="title"><?php _e( 'Update logs', YSD_MAPI_TEXT_DOMAIN ); ?></h2>
                        <div class="ysd-mapi__update-log"></div>
                    </div>
                <?php } ?>
            </div>
        </div>

        <?php if(run_user_validation()) { ?>

            <!-- Additional tabs obtained from field settings -->
            <?php foreach($fields['field_groups'] as $group) : ?>
                <div id="<?php echo $group->get_id() ?>">
                    <?php foreach ($group->get_fields() as $field) : ?>
                        <?php $field->display(); ?>
                    <?php endforeach ?>
                    <?php // Filter Screen
                        if ( 'filterJSON' == $group->get_id() ) {
                            $mapiPF = ( class_exists( 'Mapi_Property_Filters' ) ) ? new Mapi_Property_Filters() : '';
                            $mapiPF = ( ! empty( $mapiPF ) ) ? $mapiPF->get_filter() : '';
                            ?>
                            <button id="resetFilterJSON" class="button button-secondary"><?php _e( 'Reset filters', YSD_MAPI_TEXT_DOMAIN ); ?></button>
                            <?php
                        }
                    ?>
                </div>
            <?php endforeach ?>

            <div id="businessSettings">
                <div class="mapi-filter__field">
                    <table>
                        <thead style="text-align: left;">
                            <th><?php _e( 'Employee', YSD_MAPI_TEXT_DOMAIN ); ?></th>
                            <th><?php _e( 'Accountmanager ID', YSD_MAPI_TEXT_DOMAIN ); ?></th>
                        </thead>
                        <tbody>
                            <?php foreach($employees as $employee) : ?>
                                <?php $selected_value = get_post_meta($employee->ID, 'accountmanager', true); ?>
                                <tr>
                                    <td style="padding-right: 170px;"><?= $employee->post_title ?></td>
                                    <td style="padding-right: 170px;">
                                        <select name="accountmanagers[<?= $employee->ID ?>]" form="mapBusiness">
                                            <option value <?php echo !in_array($selected_value, $accountmanagers) ? 'selected' : '' ?>><?= ' ' . __( '-- select an option --', YSD_MAPI_TEXT_DOMAIN ) . ' '; ?></option>

                                            <?php foreach($accountmanagers as $accountmanager) : ?>
                                                <option value="<?= $accountmanager ?>" <?php echo $selected_value == $accountmanager ? 'selected' : ''?>><?= $accountmanager ?></option>
                                            <?php endforeach ?>
                                            <?php 
                                            ?>
                                        </select>
                                    </td>
                                </tr>
                            <?php endforeach ?>
                        </tbody>
                    </table>
                </div>
                <?php if ( is_plugin_active( 'ysp-business/ysp-business.php' ) ) : ?>
                <div class="mapi-filter__field">
                    <table>
                        <thead style="text-align: left;">
                            <th><?php _e( 'Office', YSD_MAPI_TEXT_DOMAIN ); ?></th>
                            <th><?php _e( 'Agency ID', YSD_MAPI_TEXT_DOMAIN ); ?></th>
                        </thead>
                        <tbody>
                            <?php foreach($offices as $office) : ?>
                                <?php $selected_value = get_post_meta($office->ID, 'agency_id', true); ?>
                                <tr>
                                    <td style="padding-right: 170px;"><?= $office->post_title ?></td>
                                    <td style="padding-right: 170px;">
                                        <select name="agencies[<?= $office->ID ?>]" form="mapBusiness">
                                            <option value <?php echo !in_array($selected_value, $agencies) ? 'selected' : '' ?>><?= ' ' . __( '-- select an option --', YSD_MAPI_TEXT_DOMAIN ) . ' '; ?></option>

                                            <?php foreach($agencies as $agency) : ?>
                                                <option value="<?= $agency ?>" <?php echo $selected_value == $agency ? 'selected' : ''?>><?= $agency ?></option>
                                            <?php endforeach ?>
                                        </select>
                                    </td>
                                </tr>
                            <?php endforeach ?>
                        </tbody>
                    </table>
                </div>
                <?php endif; ?>
                <div class="mapi-filter__field">
                    <table>
                        <thead style="text-align: left;">
                            <th><?php _e( 'Standard Employee', YSD_MAPI_TEXT_DOMAIN ); ?></th>         
                        </thead>
                        <tbody>
                            <tr>
                                <td style="padding-right: 170px;">
                                    <div form="formStandardEmployee">
                                        <?php
                                            if(isset($_POST['submitEmployee'])){
                                                $x = isset($_POST['standardemployee']);                                                
                                                if($x != 'yes'){
                                                    $value = 'no';
                                                }else{
                                                    $value = 'yes';
                                                }
                                            }
                                        ?>
                                        <input form="formStandardEmployee" type="checkbox" name="standardemployee" value='yes' <?php echo $value == 'yes' ? 'checked' : ''?> > 
                                        <input form="formStandardEmployee" type="submit" name="submitEmployee" value="<?php _e( 'Save', YSD_MAPI_TEXT_DOMAIN ); ?>" class="button button-primary">

                                    </div>
                                </td>
                            </tr>
                        </tbody>
                    </table>                       
                </div>
            </div>

            <!-- Update History Tab -->
            <div id="update-history">
                <div class="c-update-history">
                    <div class="c-update-history__left ysd-mapi-tab-section ysd-mapi-tab-section-vertical"></div>
                    <div class="c-update-history__right active"></div>
                </div>
            </div>

        </div>

    <?php } ?>

    <?php
        $debug_mode = get_option( 'ysd-mapi_debug_mode' );
        $sync_data = get_option( 'ysd-mapi_sync_data' );
        $disabled = ( true != $sync_data ) ? ' button-disabled' : '';
    ?>

    <div class="ysd-mapi-submit-section">
        <?php submit_button( null, 'primary', 'submit', false, null ); ?>
        <?php if ( 'enabled' == $debug_mode ) : ?>
            <a id="updateMapiNow" class="button button-secondary<?php echo $disabled; ?>" href="#" data-nonce="<?php echo wp_create_nonce( 'ajax_run_mapi_cron_nonce' ); ?>"><?php _e( 'Update now', YSD_MAPI_TEXT_DOMAIN ); ?></a>
            <a id="restoreAllDefaults" class="button button-delete button-disabled"><?php _e( 'Restore to defaults', YSD_MAPI_TEXT_DOMAIN ); ?></a>
        <?php endif; ?>
    </div>

</form>

<?php $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]"; ?>
<?php $full_link =  (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']); ?>
<?php $link = str_replace('wp-admin', '', $full_link) ?>

<?php $link_business = $link . 'wp-json/ysd-mapi/v1/business' ?>

<form action="<?= $actual_link ?>" method="POST" id="formStandardEmployee"></form>
<form id="mapBusiness" method="POST" action="<?= $link_business ?>"></form>

<?php 
if($value == 'yes'){
    $_SESSION['standard_employee'] = $value;
}else{
    $_SESSION['standard_employee'] = $value;
}
