export const property_display_toggle = $ => {

    /*
     * DISPLAY TOGGLE
     */
    const {
        defaultPropertyLayout,
    } = archiveSettings;

    var currentDisplay;

    // Support for multiple display types
    function setDisplayType(display) {
        $('#properties').removeClass('grid list map').addClass(currentDisplay = display);
        document.cookie = 'display=' + display;
    }

    // Switch display type when their links are clicked
    $(document).on('click', '.filter-setting__toggle', function (e) {
        e.preventDefault();
        setDisplayType($(this).data('display'));

        $(this).parent().find('.active').removeClass('active'); // Remove previous active class
        $(this).addClass('active'); // Add new active class
    });

    setDisplayType(document.cookie.replace(/(?:(?:^|.*;\s*)display\s*\=\s*([^;]*).*$)|^.*$/, '$1') || defaultPropertyLayout);

};