export const property_filter_inputs = $ => {
    $(document).ready(function () {

        // Filter Form
        var mapiFilterForm = document.getElementById('mapiFilterForm'),
            propertyFilterSettings = document.getElementById('propertyFilterSettings');

        if (mapiFilterForm) {

            /*
             * Remove Filter
             */
            $('.c-filter-values .c-filter-values__item').each(function () {
                $(this).on('click', function () {
                    var name = $(this).attr('name');
                    $(mapiFilterForm).find('[name="' + name + '"]').val('');
                    $(mapiFilterForm).submit(); // Submit Mapi Filter
                });
            });

            /*
             * Remove All Filters
             */
            $(document).on('click', '#removeAllFilterValues', function () {
                var href = window.location.href,
                    newHref = href.split('?');
                // console.log(newHref[0]);
                window.location.href = newHref[0];
            });

            /*
             * Auto Submit Form
             */
            if ($(mapiFilterForm).hasClass('mapi-filter--auto-submit')) {
                $('.mapi-filter__item select, .mapi-filter__item input, .filter-setting__item select, .filter-setting__item input').on('change', function (e) {
                    $(mapiFilterForm).submit(); // Submit Mapi Filter
                });
            }

            /*
             * Form On Submit
             */
            $(mapiFilterForm).on('submit', function (e) {

                // prevent default
                e.preventDefault();

                // set empty submission object
                let submission = {};

                // for each of this form submit event target object entries as key/field
                for (const [key, field] of Object.entries(e.target)) {
                    // console.log('name: ' + field.name);
                    // console.log('type: ' + field.type);
                    // console.log('value: ' + field.value);

                    // if object entry (field) has a name attribute
                    if (field.name) {

                        // if field type is
                        if (field.type === 'checkbox') {

                            // if checkbox is checked
                            if (field.checked) {

                                // if submission does not have 'type_of_property' property
                                if (!submission.hasOwnProperty(field.name)) {
                                    // set field name as array
                                    submission[field.name] = [];
                                }

                                // add name/value to submission object
                                if (field.value.length != '') {
                                    submission[field.name].push(field.value);
                                }

                            }

                            // if field type is
                        } else if (field.type === 'radio') {

                            // if field name is checked
                            var getCheckedRadioValue = $('input[name="' + field.name + '"]:checked').val();
                            if (getCheckedRadioValue != null && getCheckedRadioValue.length != '') {

                                // add name/value to submission object
                                if (getCheckedRadioValue.length != '') {
                                    submission[field.name] = getCheckedRadioValue;
                                }
                            }


                        } else if (field.value) {

                            // add name/value to submission object
                            if (field.value.length != '') {
                                submission[field.name] = field.value;
                            }

                        }

                    }

                }
                // console.log(submission);

                // now let loop through our submission and check for arrays
                for (const [name, value] of Object.entries(submission)) {

                    // if submission value is array
                    if (Array.isArray(value)) {

                        // let convert array to string
                        if (value.length != '') {
                            submission[name] = value.join(',');
                        }

                    }

                }

                // convert submission object to url safe params string
                let submission_url_params = $.param(submission),
                    action = this.action.replace('?', '');

                // console.log(action);
                // console.log(submission_url_params);

                // if we have submission params
                if (submission_url_params) {

                    // create our submission action url
                    let submission_url_action = action + (submission_url_params ? '?' + submission_url_params : '');
                    // console.log(decodeURIComponent(submission_url_action));

                    // un-comment this to actually fire the form submission
                    window.location.href = decodeURIComponent(submission_url_action);

                }

            });

        }

    });

};