export const property_gallery = $ => {

    if (typeof $.fancybox !== 'undefined') {

        /**
         * Image gallery
         */
        const run_fancybox = (index = 0) => {
            const {
                image_list,
            } = data;

            const images = image_list.map(x => {
                return {
                    id: x.id,
                    src: x.full,
                    source: x.source,
                    opts: {
                        thumb: x.thumb
                    }
                };
            });

            // Run fancybox
            $.fancybox.open(images, {
                index,
                loop: false,
                baseClass: 'property-gallery-fancybox',
                thumbs: {
                    autoStart: true,
                    axis: 'x'
                },
                buttons: [
                    // "zoom",
                    "share",
                    // "slideShow",
                    "fullScreen",
                    // "download",
                    // "thumbs",
                    "close"
                ]
            });
        };

        const run_fancybox_videos = (index = 0) => {
            const {
                video_list,
            } = data;

            const videos = video_list.map(x => {
                return {
                    // id: x.id,
                    // src: x.full,
                    // source: x.source,
                    src: x.src
                };
            });

            // Run fancybox
            $.fancybox.open(videos, {
                index,
                loop: false,
                baseClass: 'property-gallery-fancybox',
                thumbs: {
                    autoStart: true,
                    axis: 'x'
                },
                buttons: [
                    // "zoom",
                    "share",
                    // "slideShow",
                    "fullScreen",
                    // "download",
                    // "thumbs",
                    "close"
                ]
            });
        }

        const run_fancybox_floorplan = () => {
            const {
                image_list,
            } = data;

            const images = image_list.map(x => {
                return {
                    id: x.id,
                    src: x.full,
                    source: x.source,
                    opts: {
                        thumb: x.thumb
                    }
                };
            });

            const index = images.findIndex(x => x.source === "SOURCE_PROPERTY_FLOORPLAN");

            // Run fancybox
            $.fancybox.open(images, {
                index: index,
                loop: false,
                baseClass: 'property-gallery-fancybox',
                thumbs: {
                    autoStart: true,
                    axis: 'x'
                },
                buttons: [
                    // "zoom",
                    "share",
                    // "slideShow",
                    "fullScreen",
                    // "download",
                    // "thumbs",
                    "close"
                ]
            });

            
        };

        const galleryButton = document.getElementById("property-gallery__trigger");
        const videoButton = document.getElementById("property-gallery__videos");
        const floorplanButton = document.getElementById("property-gallery__floorplan");

        const galleryImageUrls = document.getElementsByClassName("property-gallery__image-link");
        const galleryVideoUrls = document.getElementsByClassName("property-gallery__video-link");
        const galleryFloorplanUrls = document.getElementsByClassName("property-gallery__floorplan-link");

        for (let i = 0; i < galleryImageUrls.length; i++) {
            (function () {
                const offset = i;
                galleryImageUrls[i].addEventListener("click", e => {
                    e.preventDefault();
                    run_fancybox(offset);
                });
            })(); // immediate invocation
        }
        for (let i = 0; i < galleryVideoUrls.length; i++) {
            (function () {
                const offset = i;
                galleryVideoUrls[i].addEventListener("click", e => {
                    e.preventDefault();
                    run_fancybox_videos(offset);
                });
            })(); // immediate invocation
        }
        for (let i = 0; i < galleryFloorplanUrls.length; i++) {
            (function () {
                const offset = i;
                galleryFloorplanUrls[i].addEventListener("click", e => {
                    e.preventDefault();
                    run_fancybox_floorplan(offset);
                });
            })(); // immediate invocation
        }

        // Check if we have gallery
        if (galleryButton) {
            galleryButton.addEventListener("click", run_fancybox);
        }
        if (videoButton) {
            videoButton.addEventListener("click", run_fancybox_videos);
        }
        if (floorplanButton) {
            floorplanButton.addEventListener("click", run_fancybox_floorplan);
        }

    }

};