(function ($) {
    'use strict';

    if (typeof Swiper !== 'undefined') {

        // Employee Slider
        $(".c-properties--slider .swiper-container").each(function (i) {

            // Data
            const slides = $(this).data("slides") ? $(this).data("slides") : 3;
            const speed = $(this).data("speed") ? $(this).data("speed") : 5000;
            const loop = $(this).data("loop") === true ? true : false;
            const space = $(this).data("space") ? $(this).data("space") : 16;

            // Autoplay
            let autoplay = $(this).data("autoplay") === true ? true : false;
            if (autoplay == true && speed > 0) {
                autoplay = {
                    delay: speed,
                }
            }

            // Carousel slider
            new Swiper($(this), {

                // Optional parameters
                autoplay: autoplay,
                loop: loop,
                spaceBetween: space,
                slidesPerView: 1,
                breakpoints: {
                    550: {
                        slidesPerView: 1
                    },
                    719: {
                        slidesPerView: 2
                    },
                    1024: {
                        slidesPerView: slides,
                        autoplayDisableOnInteraction: false,
                        disableOnInteraction: false,
                    }
                },
                setWrapperSize: true,
                pagination: {
                    el: ".swiper-pagination",
                    type: "bullets",
                    clickable: true
                },
                navigation: {
                    nextEl: '.swiper-button-next',
                    prevEl: '.swiper-button-prev',
                },

            });

        });

    }

})(jQuery);