<?php
/**
 * VC Shortcode - Property Featured
 *
 * @since 1.0
 */

class YSD_Mapi_Property_Map_WPB_Shortcode {

	public function __construct() {
		add_shortcode( 'mapi_property_map_wpb', array( $this, 'mapi_property_map_wpb_shortcode' ) );
	}

	public function mapi_property_map_wpb_shortcode( $atts ) {
        $options = shortcode_atts(
            array(
                'post_id' => '',
                'class' => '',
            ),
            $atts,
            'mapi_property_map_wpb'
        );
        
        $output = '';
        $post_id  = $options['post_id'] ? $options['post_id'] : get_queried_object_id();
        $property = $post_id ? get_post($post_id) : '';

        $propertyData = $fullAddress ='';

        if ($property) {
            $propAddr = $property->address_1 ? $property->address_1 : '';
            $propNumb = $property->house_number ? $property->house_number : '';
            $propCity = $property->city ? $property->city : '';
            
            $fullAddress = ($propAddr && $propNumb && $propCity) ? $propAddr .' '. $propNumb .', '. $propCity : '';
            
            $propertyData = array(
                'address' => $propAddr,
                'number' => $propNumb,
                'city' => $propCity,
            );
        } else {
            return; // Cancel this whole Component!
        }
        
        // Leaflet Map
        wp_enqueue_style( 'leaflet-map-style', 'https://unpkg.com/leaflet@1.7.1/dist/leaflet.css', array(), false, 'all'  );
        wp_enqueue_script( 'leaflet-map-script', 'https://unpkg.com/leaflet@1.7.1/dist/leaflet.js', array('jquery') );

        // Leaflet GeoSearch
        wp_enqueue_style( 'leaflet-search-style', 'https://unpkg.com/leaflet-geosearch@2.6.0/assets/css/leaflet.css', array(), false, 'all'  );
        wp_enqueue_script( 'leaflet-search-script', 'https://unpkg.com/leaflet-geosearch@2.6.0/dist/bundle.min.js', array('jquery') );

        // Property Map
        wp_register_script( 'property-map-script', YSD_MAPI_PLUGIN_URL . 'front/assets/src/js/shortcodes/property-map.js', array( 'jquery' ), false, true );

        $map_data = array(
            'property' => $propertyData,
            'markerContent' => $fullAddress
        );
        wp_localize_script( 'property-map-script', 'mapData', $map_data );
        wp_enqueue_script( 'property-map-script' );

        // Add custom class
        $customCss  = $options['class'] ? ' ' . $options['class'] : '';

        // Wrap all output
        $output = '<div id="propertyMap" class="c-property-map'. $customCss .'" style="min-height: 500px;">'. $output .'</div>';

        return $output;

    }
    
}

new YSD_Mapi_Property_Map_WPB_Shortcode();