<?php
/**
 * Map Shortcodes to Visual Composer.
 *
 * @since 1.0
 */
add_action( 'vc_before_init', 'mapi_property_map_wpb_integrateWithVC' );

function mapi_property_map_wpb_integrateWithVC() {
	$params = array();

	$params[] = array(
		'type'        => 'dropdown',
		'heading'     => __( 'Post ID', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'post_id',
		'admin_label' => true,
		'value'       => array_merge(
            array( __( '-- Select specific post --', YSD_MAPI_TEXT_DOMAIN ) => '' ),
            YSD_Mapi_Helpers::generate_post_list( 'property' )
        ),
		'description' => __( 'Select a post. Default: current post', YSD_MAPI_TEXT_DOMAIN ),
	);

	$params[] = array(
		'type'        => 'textfield',
		'heading'     => __( 'Custom CSS class', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'class',
		'admin_label' => true,
		'value'       => '',
		'group'       => __( 'Advanced setup', YSD_MAPI_TEXT_DOMAIN ),
		'description' => __( 'ex. card card--hover', YSD_MAPI_TEXT_DOMAIN ),
	);

	vc_map(
		array(
			'name'     => __( 'Property Map', YSD_MAPI_TEXT_DOMAIN ),
			'base'     => 'mapi_property_map_wpb',
			'category' => 'MAPI',
			'icon'     => MAPI_WPBC_SYMBOL,
			'params'   => $params,
		)
	);
}
