<?php
/**
 * Map Shortcodes to Visual Composer.
 *
 * @since 1.0
 */
add_action( 'vc_before_init', 'mapi_property_related_integrateWithVC' );

function mapi_property_related_integrateWithVC() {
	$params = array();

	$params[] = array(
		'type'        => 'dropdown',
		'heading'     => __( 'Layout', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'layout',
		'admin_label' => true,
		'value'       => array(
			__( 'List', YSD_MAPI_TEXT_DOMAIN )    => 'list',
			__( 'Slider', YSD_MAPI_TEXT_DOMAIN )  => 'slider',
		),
		'std'         => 'list',
		'description' => __( 'Set which layout to use. Default: List.', YSD_MAPI_TEXT_DOMAIN ),
	);

	$params[] = array(
		'type'        => 'dropdown',
		'heading'     => __( 'Amount of items', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'amount',
		'admin_label' => true,
		'value'       => array(
			__( 'All', YSD_MAPI_TEXT_DOMAIN )    => '-1',
			__( 'Two', YSD_MAPI_TEXT_DOMAIN )    => '2',
			__( 'Three', YSD_MAPI_TEXT_DOMAIN )  => '3',
			__( 'Four', YSD_MAPI_TEXT_DOMAIN )   => '4',
			__( 'Five', YSD_MAPI_TEXT_DOMAIN )   => '5',
			__( 'Six', YSD_MAPI_TEXT_DOMAIN )    => '6',
			__( 'Custom', YSD_MAPI_TEXT_DOMAIN ) => 'custom',
		),
		'std'         => '4',
		'description' => __( 'Set how many items to show. Default: All.', YSD_MAPI_TEXT_DOMAIN ),
	);

    $params[] = array(
        'type'        => 'textfield',
        'heading'     => __( 'Custom amount of items', YSD_MAPI_TEXT_DOMAIN ),
        'param_name'  => 'amount_custom',
        'admin_label' => true,
        'value'       => '',
        'description' => __( 'Set custom amount of items.', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'amount',
            'value' => 'custom',
        ),
    );

	$params[] = array(
		'type'        => 'dropdown',
		'heading'     => __( 'Items per row', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'per_row',
		'admin_label' => true,
		'value'       => array(
			__( 'One', YSD_MAPI_TEXT_DOMAIN )    => '1',
			__( 'Two', YSD_MAPI_TEXT_DOMAIN )    => '2',
			__( 'Three', YSD_MAPI_TEXT_DOMAIN )  => '3',
			__( 'Four', YSD_MAPI_TEXT_DOMAIN )   => '4',
			__( 'Five', YSD_MAPI_TEXT_DOMAIN )   => '5',
			__( 'Six', YSD_MAPI_TEXT_DOMAIN )    => '6',
			__( 'Custom', YSD_MAPI_TEXT_DOMAIN ) => 'custom',
		),
		'std'         => '4',
		'description' => __( 'Select how many items to show per row. Set custom to provide your own custom number in CSS (customizer).', YSD_MAPI_TEXT_DOMAIN ),
	);

	$params[] = array(
		'type'        => 'textfield',
		'heading'     => __( 'Custom CSS class', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'class',
		'admin_label' => true,
		'value'       => '',
		'description' => __( 'ex. card card--hover', YSD_MAPI_TEXT_DOMAIN ),
	);

	$params[] = array(
		'type'        => 'dropdown',
		'heading'     => __( 'Compare with', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'compare_with',
		'admin_label' => true,
		'value'       => array_merge(
            array( __( '-- Current --', YSD_MAPI_TEXT_DOMAIN ) => '' ),
            YSD_Mapi_Helpers::generate_post_list( 'property' )
        ),
		'group'       => __( 'Settings', YSD_MAPI_TEXT_DOMAIN ),
		'description' => __( 'Select compare with object. Default: Current', YSD_MAPI_TEXT_DOMAIN ),
	);

	$params[] = array(
		'type'        => 'dropdown',
		'heading'     => __( 'Related by', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'relatedby',
		'admin_label' => true,
		'value'       => array(
			__( 'City', YSD_MAPI_TEXT_DOMAIN ) => 'city',
			__( 'Price', YSD_MAPI_TEXT_DOMAIN ) => 'price',
		),
		'std'         => 'city',
		'group'       => __( 'Settings', YSD_MAPI_TEXT_DOMAIN ),
		'description' => __( 'Select related by. Default: City', YSD_MAPI_TEXT_DOMAIN ),
	);

	$params[] = array(
		'type'        => 'dropdown',
		'heading'     => __( 'Price marge', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'relatedby_price',
		'admin_label' => true,
		'value'       => array(
			'100'       => '100',
			'250'       => '250',
			'500'       => '500',
			'1,000'     => '1000',
			'10,000'    => '10000',
			'25,000'    => '25000',
			'50,000'    => '50000',
			'100,000'   => '100000',
			'250,000'   => '250000',
			'500,000'   => '500000',
			'1,000,000' => '1000000',
		),
		'std'         => '100000',
		'group'       => __( 'Settings', YSD_MAPI_TEXT_DOMAIN ),
		'description' => __( 'Select related by price amount. Default: 100.000', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'relatedby',
            'value' => 'price',
        ),
	);

	$params[] = array(
		'type'        => 'dropdown',
		'heading'     => __( 'Order by', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'orderby',
		'admin_label' => true,
		'value'       => array(
			__( 'Date', YSD_MAPI_TEXT_DOMAIN )       => 'date',
			__( 'Title', YSD_MAPI_TEXT_DOMAIN )      => 'title',
			__( 'Menu order', YSD_MAPI_TEXT_DOMAIN ) => 'menu_order',
			__( 'Random', YSD_MAPI_TEXT_DOMAIN )     => 'rand',
		),
		'std'         => 'date',
		'group'       => __( 'Order', YSD_MAPI_TEXT_DOMAIN ),
		'description' => __( 'Select order by. Default: Date', YSD_MAPI_TEXT_DOMAIN ),
	);

	$params[] = array(
		'type'        => 'dropdown',
		'heading'     => __( 'Order', YSD_MAPI_TEXT_DOMAIN ),
		'param_name'  => 'order',
		'admin_label' => true,
		'value'       => array(
			__( 'Ascendent', YSD_MAPI_TEXT_DOMAIN )  => 'ASC',
			__( 'Descendent', YSD_MAPI_TEXT_DOMAIN ) => 'DESC',
		),
		'std'         => 'DESC',
		'group'       => __( 'Order', YSD_MAPI_TEXT_DOMAIN ),
		'description' => __( 'Select order of posts (default: Ascendent)', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'orderby',
            'value' => array(
                'date',
                'title',
                'menu_order',
            ),
        ),
	);

    $params[] = array(
        'type'        => 'checkbox',
        'heading'     => __( 'Slider autoplay', YSD_MAPI_TEXT_DOMAIN ),
        'param_name'  => 'slider_auto',
        'admin_label' => true,
        'value'       => array( __( 'Yes', YSD_MAPI_TEXT_DOMAIN ) => 'true' ),
        'group'       => __( 'Slider', YSD_MAPI_TEXT_DOMAIN ),
        'description' => __( 'Enable automatic playing of the slides.', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'layout',
            'value' => 'slider',
        ),
    );

    $params[] = array(
        'type'        => 'textfield',
        'heading'     => __( 'Slider speed', YSD_MAPI_TEXT_DOMAIN ),
        'param_name'  => 'slider_speed',
        'admin_label' => true,
        'value'       => '',
        'std'         => '5000',
        'group'       => __( 'Slider', YSD_MAPI_TEXT_DOMAIN ),
        'description' => __( 'default: 5000 (miliseconds)', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'layout',
            'value' => 'slider',
        ),
    );

    $params[] = array(
        'type'        => 'checkbox',
        'heading'     => __( 'Slider loop', YSD_MAPI_TEXT_DOMAIN ),
        'param_name'  => 'slider_loop',
        'admin_label' => true,
        'value'       => array( __( 'Yes', YSD_MAPI_TEXT_DOMAIN ) => 'true' ),
        'group'       => __( 'Slider', YSD_MAPI_TEXT_DOMAIN ),
        'description' => __( 'Enable looping of the slides.', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'layout',
            'value' => 'slider',
        ),
    );

    $params[] = array(
        'type'        => 'textfield',
        'heading'     => __( 'Slider space between', YSD_MAPI_TEXT_DOMAIN ),
        'param_name'  => 'slider_space',
        'admin_label' => true,
		'std'         => '16',
        'group'       => __( 'Slider', YSD_MAPI_TEXT_DOMAIN ),
        'description' => __( 'Set the space between the slides in pixels (number only). Default: 16', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'layout',
            'value' => 'slider',
        ),
    );

    $params[] = array(
        'type'        => 'checkbox',
        'heading'     => __( 'Slider pagination', YSD_MAPI_TEXT_DOMAIN ),
        'param_name'  => 'slider_pagi',
        'admin_label' => true,
        'value'       => array( __( 'Yes', YSD_MAPI_TEXT_DOMAIN ) => 'true' ),
        'group'       => __( 'Slider', YSD_MAPI_TEXT_DOMAIN ),
        'description' => __( 'Enable slider pagination.', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'layout',
            'value' => 'slider',
        ),
    );

    $params[] = array(
        'type'        => 'checkbox',
        'heading'     => __( 'Slider navigation', YSD_MAPI_TEXT_DOMAIN ),
        'param_name'  => 'slider_navi',
        'admin_label' => true,
        'value'       => array( __( 'Yes', YSD_MAPI_TEXT_DOMAIN ) => 'true' ),
        'group'       => __( 'Slider', YSD_MAPI_TEXT_DOMAIN ),
        'description' => __( 'Enable slider navigation.', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'layout',
            'value' => 'slider',
        ),
    );

    $params[] = array(
        'type'        => 'colorpicker',
        'heading'     => __( 'Slider pagination color', YSD_MAPI_TEXT_DOMAIN ),
        'param_name'  => 'slider_pagi_clr',
        'admin_label' => true,
        'value'       => '',
        'group'       => __( 'Slider', YSD_MAPI_TEXT_DOMAIN ),
        'description' => __( 'Set slider pagination color.', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'slider_pagi',
            'value' => 'true',
        ),
    );

    $params[] = array(
        'type'        => 'colorpicker',
        'heading'     => __( 'Slider navigation color', YSD_MAPI_TEXT_DOMAIN ),
        'param_name'  => 'slider_navi_clr',
        'admin_label' => true,
        'value'       => '',
        'group'       => __( 'Slider', YSD_MAPI_TEXT_DOMAIN ),
        'description' => __( 'Set slider navigation color.', YSD_MAPI_TEXT_DOMAIN ),
        'dependency'  => array(
            'element' => 'slider_navi',
            'value' => 'true',
        ),
    );

    // Add Margins and Paddings
    if ( function_exists( 'ysp_vc_spacing_params' ) ) {
        $params = array_merge( $params, ysp_vc_spacing_params() );
    }

	vc_map(
		array(
			'name'     => __( 'Property Related', YSD_MAPI_TEXT_DOMAIN ),
			'base'     => 'mapi_property_related',
			'category' => 'MAPI',
			'icon'     => MAPI_WPBC_SYMBOL,
			'params'   => $params,
		)
	);
}
