<?php


/**
 * Property Format - Type
 */
if ( ! function_exists( 'getPropertyType' ) ) {

    function getPropertyType( $property ) {
        
        $type = $property->type;

        switch ( $type ) {
            case 1:
                $type = __( 'House', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 2:
                $type = __( 'Apartment', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 3:
                $type = __( 'Parking spot', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 4:
                $type = __( 'Building plot', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 5:
                $type = __( 'Office space', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 6:
                $type = __( 'Business hall', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 7:
                $type = __( 'Other private houses', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 8:
                $type = __( 'Other BOG properties', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 9:
                $type = __( 'Other properties', YSD_MAPI_TEXT_DOMAIN );
                break;
        }

        $data['label'] = __( 'Kind of house', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $type;
        
        return $data;

    }
}


/**
 * Property Format - Construction Year
 */
if ( ! function_exists( 'getPropertyConstructionYear' ) ) {

    function getPropertyConstructionYear( $property ) {
        
        $type = $property->year_built;

        $data['label'] = __( 'Year of construction', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $type;
        
        return $data;

    }
}

/**
 * Property Format - Build Type @todo: fix the data
 */
if ( ! function_exists( 'getPropertyBuildType' ) ) {

    function getPropertyBuildType( $property ) {
        
        $build_type = $property->build_type;

        switch($build_type) {
            case 'Nieuwbouw':
                $build_type = __('New construction', YSD_MAPI_TEXT_DOMAIN);
                break;
            case 'Bestaande bouw':
                $build_type = __('Existing construction', YSD_MAPI_TEXT_DOMAIN);
                break;
            case 'Niet van toepassing':
                $build_type = __('Not applicable', YSD_MAPI_TEXT_DOMAIN);
                break;
        }

        $data['label'] = __( 'Build type', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $build_type;
        
        return $data;

    }
}

/**
 * Property Format - Construction Period
 */
if ( ! function_exists( 'getPropertyConstructionPeriod' ) ) {

    function getPropertyConstructionPeriod( $property ) {
        
        $year_built_period = $property->year_built_period;
        $year_built_period = str_replace( '_', '', $year_built_period );
        $year_built_period = str_replace( 'VANAF', '', $year_built_period );
        $year_built_period = str_replace( 'TM', '-', $year_built_period );

        $data['label'] = __( 'Construction period', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $year_built_period;
        
        return $data;

    }
}

/**
 * Property Format - Under Construction
 */
if ( ! function_exists( 'getPropertyUnderConstruction' ) ) {

    function getPropertyUnderConstruction( $property ) {
        
        $under_construction = $property->under_construction;

        $under_construction = ( ! empty( $under_construction ) ) ? __( "Yes", YSD_MAPI_TEXT_DOMAIN ) : '';

        $data['label'] = __( 'Under construction', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $under_construction;
        
        return $data;

    }
}