<?php


/**
 * Property Format - Energy Label
 */
if ( ! function_exists( 'getPropertyEnergyLabel' ) ) {

    function getPropertyEnergyLabel( $property ) {
        
        $energy = $property->energy_label;
        $energy = str_replace( '_', '', $energy );
        $energy = str_replace( 'P', '+', $energy );
        $energy = ( ! empty( $energy ) ) ? $energy : __( 'Not available', YSD_MAPI_TEXT_DOMAIN );

        $data['label'] = __( 'Label', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $energy;
        
        return $data;

    }
}

/**
 * Property Format - Energy Index
 */
if ( ! function_exists( 'getPropertyEnergyIndex' ) ) {

    function getPropertyEnergyIndex( $property ) {
        
        $energy_index = $property->energy_index;

        $data['label'] = __( 'Index', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $energy_index;
        
        return $data;

    }
}

/**
 * Property Format - Energy Label End Date
 */
if ( ! function_exists( 'getPropertyEnergyLabelEndDate' ) ) {

    function getPropertyEnergyLabelEndDate( $property ) {
        
        $energy_label_end_date = $property->energy_label_end_date;
        $energy_label_end_date = ( ! empty( $energy_label_end_date ) ) ? date( 'd-m-Y', strtotime($property->energy_label_end_date) ) : '';

        $data['label'] = __( 'Label end date', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $energy_label_end_date;
        
        return $data;

    }
}

/**
 * Property Format - Energy Insulation
 */
if ( ! function_exists( 'getPropertyEnergyInsulation' ) ) {

    function getPropertyEnergyInsulation( $property ) {
        
        if ( ! function_exists( 'getFormattedValue' ) ) {
            return;
        }
        
        $energy_insulation = getFormattedValue( 'EnergyInsulation', $property->energy_insulation );

        $data['label'] = __( 'Insulation', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $energy_insulation;
        
        return $data;

    }
}

/**
 * Property Format - Energy EPC
 */
if ( ! function_exists( 'getPropertyEnergyEpc' ) ) {

    function getPropertyEnergyEpc( $property ) {
        
        $energy_epc = $property->energy_epc;

        $data['label'] = __( 'EPC', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $energy_epc;
        
        return $data;

    }
}

/**
 * Property Format - Energy Heating
 */
if ( ! function_exists( 'getPropertyEnergyHeating' ) ) {

    function getPropertyEnergyHeating( $property ) {
        
        if ( ! function_exists( 'getFormattedValue' ) ) {
            return;
        }
        
        $energy_heating = getFormattedValue( 'EnergyHeating', $property->energy_heating );

        $data['label'] = __( 'Heating', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $energy_heating;
        
        return $data;

    }
}

/**
 * Property Format - Boiler Type
 */
if ( ! function_exists( 'getPropertyBoilerType' ) ) {

    function getPropertyBoilerType( $property ) {
        
        $boiler_type = $property->boiler_type;

        $data['label'] = __( 'Boiler type', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $boiler_type;
        
        return $data;

    }
}

/**
 * Property Format - Boiler Year
 */
if ( ! function_exists( 'getPropertyBoilerYear' ) ) {

    function getPropertyBoilerYear( $property ) {
        
        $boiler_year = $property->boiler_year;

        $data['label'] = __( 'Boiler year', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $boiler_year;
        
        return $data;

    }
}

/**
 * Property Format - Boiler Property
 */
if ( ! function_exists( 'getPropertyBoilerProperty' ) ) {

    function getPropertyBoilerProperty( $property ) {
        
        $boiler_property = $property->boiler_property;
        $boiler_property = ( ! empty( $boiler_property ) ) ? __( 'Owned', YSD_MAPI_TEXT_DOMAIN ) : '';

        $data['label'] = __( 'Boiler property', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $boiler_property;
        
        return $data;

    }
}

/**
 * Property Format - Boiler Combi
 */
if ( ! function_exists( 'getPropertyBoilerCombi' ) ) {

    function getPropertyBoilerCombi( $property ) {
        
        $boiler_combi = $property->boiler_combi;

        if ( ! empty( $boiler_combi ) ) {
            switch($boiler_combi) {
                case 0 :
                    $boiler_combi = __( 'No', YSD_MAPI_TEXT_DOMAIN );
                    break;
                case 1 :
                    $boiler_combi = __( 'Yes', YSD_MAPI_TEXT_DOMAIN );
                    break;
            }
        } else {
            $boiler_combi = '';
        }

        $data['label'] = __( 'Boiler combi', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $boiler_combi;
        
        return $data;

    }
}