<?php

/**
 * Property Format - Exterior Space Location
 */
if ( ! function_exists( 'getPropertyExteriorSpaceLocation' ) ) {

    function getPropertyExteriorSpaceLocation( $property ) {
        
        if ( ! function_exists( 'getFormattedValue' ) ) {
            return;
        }

        $exterior_space_location = getFormattedValue( 'ExteriorSpaceLocation', $property->exterior_space_location );

        $data['label'] = __( 'Location', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $exterior_space_location;
        
        return $data;

    }
}

/**
 * Property Format - Exterior Space Types
 */
if ( ! function_exists( 'getPropertyExteriorSpaceTypes' ) ) {

    function getPropertyExteriorSpaceTypes( $property ) {
        
        if ( ! function_exists( 'getFormattedValue' ) ) {
            return;
        }
        
        $exterior_space_types = getFormattedValue( 'ExteriorSpaceTypes', $property->exterior_space_types );

        $data['label'] = __( 'Garden', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $exterior_space_types;
        
        return $data;

    }
}

/**
 * Property Format - Exterior Space Area
 */
if ( ! function_exists( 'getPropertyExteriorSpaceArea' ) ) {

    function getPropertyExteriorSpaceArea( $property ) {
        
        $exterior_space_area = $property->exterior_space_area;

        $volume_unit = get_option( 'ysd-mapi_realtor_property_unit', 'metric' );
        $volume_unit = ( 'imperial' === $volume_unit ) ? ' f²' :  ' m²';

        $exterior_space_area = ( ! empty( $exterior_space_area ) ) ? $property->exterior_space_area . $volume_unit : '';

        $data['label'] = __( 'Area', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $exterior_space_area;
        
        return $data;

    }
}

/**
 * Property Format - Exterior Space Garden
 */
if ( ! function_exists( 'getPropertyExteriorSpaceGarden' ) ) {

    function getPropertyExteriorSpaceGarden( $property ) {
        
        $exterior_space_garden = $property->exterior_space_garden;
        $exterior_space_garden = ( ! empty( $exterior_space_garden ) && 'unknown' != $exterior_space_garden ) ? $property->exterior_space_garden : '';

        $data['label'] = __( 'Garden', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $exterior_space_garden;
        
        return $data;

    }
}

