<?php


/**
 * Property Format - Number of Bedrooms
 */
if ( ! function_exists( 'getPropertyBedrooms' ) ) {

    function getPropertyBedrooms( $property ) {
        
        $number_of_bedrooms = $property->number_of_bedrooms;
        $number_of_bedrooms = ( ! empty( $number_of_bedrooms ) ) ? sprintf( _n( '%s bedroom', '%s bedrooms', $number_of_bedrooms, YSD_MAPI_TEXT_DOMAIN ), number_format_i18n( $number_of_bedrooms ) ) : '';

        $data['label'] = __( 'Number of bedrooms', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $number_of_bedrooms;
        
        return $data;
    }
}


/**
 * Property Format - Number of Rooms
 */
if ( ! function_exists( 'getPropertyRooms' ) ) {

    function getPropertyRooms( $property ) {
        
        $number_of_rooms = $property->number_of_rooms;
        $number_of_rooms = ( ! empty( $number_of_rooms ) ) ? sprintf( _n( '%s room', '%s rooms', $number_of_rooms, YSD_MAPI_TEXT_DOMAIN ), number_format_i18n( $number_of_rooms ) ) : '';

        $data['label'] = __( 'Number of rooms', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $number_of_rooms;
        
        return $data;
    }
}

/**
 * Property Format - Number of Bathrooms
 */
if ( ! function_exists( 'getPropertyBathrooms' ) ) {

    function getPropertyBathrooms( $property ) {
        
        $number_of_bathrooms = $property->number_of_bathrooms;
        $number_of_bathrooms = ( ! empty( $number_of_bathrooms ) ) ? sprintf( _n( '%s bathroom', '%s bathrooms', $number_of_bathrooms, YSD_MAPI_TEXT_DOMAIN ), number_format_i18n( $number_of_bathrooms ) ) : '';

        $data['label'] = __( 'Number of bathrooms', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $number_of_bathrooms;
        
        return $data;
    }
}

/**
 * Property Format - Number of Stories
 */
if ( ! function_exists( 'getPropertyStories' ) ) {

    function getPropertyStories( $property ) {
        
        $number_of_stories = $property->number_of_stories;
        $number_of_stories = ( ! empty( $number_of_stories ) ) ? sprintf( _n( '%s story', '%s stories', $number_of_stories, YSD_MAPI_TEXT_DOMAIN ), number_format_i18n( $number_of_stories ) ) : '';

        $data['label'] = __( 'Number of stories', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $number_of_stories;
        
        return $data;
    }
}

/**
 * Property Format - Located at floor @todo: fix the data
 */
if ( ! function_exists( 'getPropertyLocatedAtFloor' ) ) {

    function getPropertyLocatedAtFloor( $property ) {
        
        $located_at_floor = $property->number_of_floors;

        $data['label'] = __( 'Located at', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $located_at_floor;
        $data['value_label'] = __('floor', YSD_MAPI_TEXT_DOMAIN);
        
        return $data;
    }
}

/**
 * Property Format - Facilities
 */
if ( ! function_exists( 'getPropertyFacilities' ) ) {

    function getPropertyFacilities( $property ) {
        
        $facilities = $property->facilities;

        $data['label'] = __( 'Facilities', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $facilities;
        
        return $data;
    }
}

/**
 * Property Format - Furnished
 */
if ( ! function_exists( 'getPropertyFurnished' ) ) {

    function getPropertyFurnished( $property ) {
        
        $furnished = $property->is_furnished;

        switch ( $furnished ) {
            case 0:
                $furnished = __( 'No', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 1:
                $furnished = __( 'Yes', YSD_MAPI_TEXT_DOMAIN );
                break;
        }

        $data['label'] = __( 'Furnished', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $furnished;
        
        return $data;

    }
}


/**
 * Property Format - Upholstered
 */
if ( ! function_exists( 'getPropertyUpholstered' ) ) {

    function getPropertyUpholstered( $property ) {
        
        $upholstered = $property->is_upholstered;

        switch ( $upholstered ) {
            case 0:
                $upholstered = __( 'No', YSD_MAPI_TEXT_DOMAIN );
                break;
            case 1:
                $upholstered = __( 'Yes', YSD_MAPI_TEXT_DOMAIN );
                break;
        }

        $data['label'] = __( 'Upholstered', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $upholstered;
        
        return $data;

    }
}