<?php

if ( ! function_exists( 'getPropertyUsableArea' ) ) {

    /**
     * Property Format - Living Area
     */
    function getPropertyUsableArea( $property ) {

        $volume_units = getRealtorVolumeUnits( 'square' );
        $usable_area = $property->usable_area;
        if ( $usable_area ) {
            $usable_area = $usable_area .' '. $volume_units;
        }
        
        $data['label'] = __( 'Living area', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $usable_area;

        return $data;
    }
}

if ( ! function_exists( 'getPropertyPlotArea' ) ) {

    /**
     * Property Format - Plot size
     */
    function getPropertyPlotArea( $property ) {

        $volume_units = getRealtorVolumeUnits( 'square' );
        $plot_area = $property->plot_area;
        if ( $plot_area ) {
            $plot_area = $plot_area .' '. $volume_units;
        }
        
        $data['label'] = __( 'Plot size', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $plot_area;

        return $data;
    }
}

if ( ! function_exists( 'getPropertyVolumeArea' ) ) {

    /**
     * Property Format - Volume Area
     */
    function getPropertyVolumeArea( $property ) {

        $volume_units = getRealtorVolumeUnits( 'cubic' );
        $volume_area = $property->volume_area;
        if ( $volume_area ) {
            $volume_area = $volume_area .' '. $volume_units;
        }
        
        $data['label'] = __( 'Volume in cubic meters', YSD_MAPI_TEXT_DOMAIN );
        $data['value'] = $volume_area;

        return $data;
    }
}