<?php
/**
 * Function to feed fancybox with single property image gallery image array.
 */
function get_property_js_data() {
	$images = get_mapi_property_images();
	$videos = get_mapi_property_videos();

	$data = array_merge($images, $videos);

	return $data;
}

function get_mapi_property_images() {

	/**
	 * Setup default property
	 */
	$data = array(
		'image_list' => array(),
	);

	if ( is_singular( 'property' ) ) {
        
        // Attachments Args
        $attachments_args = array(
            'post_parent' => get_the_ID(),
            'post_type' => 'attachment',
            'numberposts' => -1, // show all
            'post_status' => 'any',
            'post_mime_type' => 'image',
            'orderby' => 'date',
            'order' => 'ASC'
        );

        // Get Attachments
        $images = get_posts( $attachments_args );

		// Move featured image to the first index
		$featured_image = get_post(get_post_thumbnail_id());
		if (($key = array_search($featured_image, $images)) !== false) {
			unset($images[$key]);
		}
		array_unshift($images, $featured_image);

        if ( ! empty( $images ) ) {
            foreach ( $images as $image ) {
                if ( ! empty( $image ) && $image->post_type === 'attachment' ) {
                    $source = $image->post_excerpt;
                    $img       = wp_get_attachment_image_src( $image->ID, 'full', false, '' );
                    $img_thumb = wp_get_attachment_image_src( $image->ID, 'thumbnail', false, '' );

                    $data['image_list'][] = array(
                        'full'  => $img[0],
                        'thumb' => $img_thumb[0],
                        'source' => $source
                    );
                }
            }
        }
	}

	return $data;
}

function get_mapi_property_videos() {

	/**
	 * Setup default property
	 */

	$data = array(
		'video_list' => array(),
	);

    if ( is_singular( 'property' ) ) {
        
        // Attachments Args
        $attachments_args = array(
            'post_parent' => get_the_ID(),
            'post_type' => 'attachment',
            'numberposts' => -1, // show all
            'post_status' => 'any',
            'orderby' => 'date',
            'order' => 'ASC',
            'post_mime_type' => 'video',
        );

        $video_url = get_post_meta( get_the_ID(), 'video_url', true );

        // Get Attachments
        $videos = get_posts( $attachments_args );

        if ( !empty( $videos )) {
            foreach ( $videos as $video ) {

                if ( ! empty( $video ) && $video->post_type === 'attachment' ) {
                    $url = $video->guid;
                    $data['video_list'][] = array(
                        'src' => $url
                    );
                }
            }
        }
        if(!empty($video_url) && empty( $videos )){
            $data['video_list'][] = array(
                'src' => $video_url
            );
        }
	}

	return $data;
	
}