<?php

/********************
 * Single Functions
*********************/

if ( ! function_exists( 'mapi_property_remove_spacing' ) ) {

    /**
     * Property Single - Remove Spacing (Before & After)
     */
    function mapi_property_remove_spacing() {
        if ( is_singular( 'property' ) ) {
            remove_action('ysp_before_content', 'ysp_spacing_before_content');
            remove_action('ysp_after_content', 'ysp_spacing_after_content');
        }
    }
}

if ( ! function_exists( 'mapi_property_before_wrapper_output' ) ) {

    /*
     * Property Single Wrapper - Start
     */
    function mapi_property_before_wrapper_output() {
        
        $output = $holder_class = '';

        // Holder Class
        $holder_class = get_option( 'ysd-mapi_single_holder_class' );
        $holder_class = ! empty( $holder_class ) && is_ysp_theme() ? ' ' . $holder_class : '';
        
        $output .= '<div class="mapi-property-single-wrapper">';
        $output .= '<div class="mapi-property-single'. $holder_class .'">';
        if (is_ysp_theme()) {
            $output .= '<div class="c-container">';
            $output .= '<div class="c-row">';
            $output .= '<div id="primary" class="content-area c-col">';
            $output .= '<main id="main" class="site-main">';
        }

        echo $output;
    }
}

if ( ! function_exists( 'mapi_property_after_wrapper_output' ) ) {

    /*
     * Property Single Wrapper - End
     */
    function mapi_property_after_wrapper_output() {

        $output = '';
        if (is_ysp_theme()) {
            $output .= '</main>';
            $output .= '</div>';
            $output .= '</div>';
            $output .= '</div>';
        }
        $output .= '</div>';
        $output .= '</div>';

        echo $output;
    }
}

if ( ! function_exists( 'property_single_inner_start' ) ) {

    /*
     * Property Single Inner Wrapper - Start
     */
    function property_single_inner_start() {
        ?>

        <div class="property-entry-content">
            <div class="c-row">

        <?php
    }
}

if ( ! function_exists( 'property_single_inner_end' ) ) {

    /*
     * Property Single Inner Wrapper - End
     */
    function property_single_inner_end() {
        ?>
        
            </div>
            <?php do_action( 'property_single_inner_end_extra' ); ?>
        </div>

        <?php
    }
}

if ( ! function_exists( 'mapi_single_alternative_content' ) ) {
    
    /**
     * Archive Alternative Content
     */
	function mapi_single_alternative_content() {
        
        // Options
        $templatera = get_option( 'ysd-mapi_single_template_hooks' );
        $altContent = get_option( 'ysd-mapi_single_alt_content' );

        // Holder Class
        $holder_class = get_option( 'ysd-mapi_single_holder_class' );
        $holder_class = ! empty( $holder_class ) ? 'mapi-property-single ' . $holder_class : 'mapi-property-single';
        
        if ( 'disabled' == $templatera ) {
            echo '<div class="'. $holder_class .'">';
                echo do_shortcode( $altContent );
            echo '</div>';
        }
	}
}

if ( ! function_exists( 'mapi_single_main_start' ) ) {
    
    /**
     * Property Single Main Start
     */
	function mapi_single_main_start() {
        $option = get_option( 'ysd-mapi_single_main_columns' );
        $class = ( ! empty( $option ) ) ? $option : 'c-col-12 c-col-md-7 c-col-lg-8';
        ?>
        <div class="<?php echo $class; ?>">
        <?php
	}
}

if ( ! function_exists( 'mapi_single_main_end' ) ) {
    
    /**
     * Property Single Main End
     */
	function mapi_single_main_end() {
        ?>
        </div>
        <?php
	}
}

if ( ! function_exists( 'mapi_single_side_start' ) ) {
    
    /**
     * Property Single Side Start
     */
	function mapi_single_side_start() {
        $option = get_option( 'ysd-mapi_single_aside_columns' );
        $class = ( ! empty( $option ) ) ? $option : 'c-col-12 c-col-md-5 c-col-lg-4';
        ?>
        <div class="<?php echo $class; ?>">
        <?php
	}
}

if ( ! function_exists( 'mapi_single_side_end' ) ) {
    
    /**
     * Property Single Side End
     */
	function mapi_single_side_end() {
        ?>
        </div>
        <?php
	}
}

if ( ! function_exists( 'mapi_single_side_sidebar_widget_area' ) ) {
    
    /**
     * Property Single Sidebar
     */
	function mapi_single_side_sidebar() {

        $sidebar = get_option( 'ysd-mapi_single_sidebar_widget_area', true );

        if ( true == $sidebar ) {   
            if ( is_active_sidebar( 'mapi-single-sidebar' ) ) {
                dynamic_sidebar( 'mapi-single-sidebar' );
            }
        }
	}
}