<?php

/********************
 * Archive Hooks
*********************/

/**
 * Archive - Loop Hooks
 */
add_action( 'pre_get_posts', 'mapi_archive_pre_get_posts', 1 );
add_action( 'mapi_properties_loop', 'mapi_properties_loop_header', 10 );
add_action( 'mapi_properties_loop', 'mapi_properties_loop_content', 20 );
add_action( 'mapi_properties_loop', 'mapi_properties_loop_footer', 30 );

/**
 * Archive - Layout Hooks
 */
add_action( 'ysp_after_header', 'mapi_remove_content_spacing' );
add_action( 'mapi_properties_before_wrapper', 'mapi_properties_before_wrapper_output', 10 );
add_action( 'mapi_properties_after_wrapper', 'mapi_properties_after_wrapper_output', 10 );
add_action( 'mapi_before_properties_main', 'mapi_archive_main_start', 10 );
add_action( 'mapi_after_properties_main', 'mapi_archive_main_end', 10 );
add_action( 'mapi_properties_sidebar', 'mapi_archive_side_start', 10 );
add_action( 'mapi_properties_sidebar', 'mapi_archive_side_search', 20 );
add_action( 'mapi_properties_sidebar', 'mapi_archive_side_sidebar', 30 );
add_action( 'mapi_properties_sidebar', 'mapi_archive_side_end', 40 );

/**
 * Archive - No Properties Found Message
 */
add_action( 'mapi_no_properties_found', 'mapi_no_properties_found_message', 10 );


/********************
 * Single Hooks
*********************/

/**
 * Single - Layout Hooks
 */
add_action( 'ysp_before_content', 'mapi_property_remove_spacing', 5 );
add_action( 'mapi_property_before_wrapper', 'mapi_property_before_wrapper_output', 10 );
add_action( 'mapi_property_after_wrapper', 'mapi_property_after_wrapper_output', 10 );
add_action( 'mapi_property_start', 'property_single_inner_start', 100 );
add_action( 'mapi_property_end', 'property_single_inner_end', 100 );
add_action( 'mapi_property_main', 'mapi_single_main_start', 5 );
add_action( 'mapi_property_main', 'mapi_single_main_end', 100 );
add_action( 'mapi_property_side', 'mapi_single_side_start', 5 );
add_action( 'mapi_property_side', 'mapi_single_side_end', 100 );
add_action( 'mapi_print_css', 'mapi_add_icons_script', 100 );

/**
 * Single - Components (Classes)
 */
// Header Shortcode
$show = get_option( 'ysd-mapi_single_show_header', true );
if ( true == $show ) {
    add_action( 'mapi_property_start', array( 'YSD_Mapi_Property_Header_Shortcode', 'mapi_property_header_shortcode' ), 10 );
}
// Gallery Shortcode
$show = get_option( 'ysd-mapi_single_show_gallery', true );
if ( true == $show ) {
    add_action( 'mapi_property_start', array( 'YSD_Mapi_Property_Gallery_Shortcode', 'mapi_property_gallery_shortcode' ), 20 );
}
// Status Shortcode
$show = get_option( 'ysd-mapi_single_show_status', true );
if ( true == $show ) {
    add_action( 'mapi_property_main', array( 'YSD_Mapi_Property_Status_Shortcode', 'mapi_property_status_shortcode' ), 5 );
}
// Description Shortcode
$show = get_option( 'ysd-mapi_single_show_desc', true );
if ( true == $show ) {
    add_action( 'mapi_property_main', array( 'YSD_Mapi_Property_Description_Shortcode', 'mapi_property_description_shortcode' ), 10 );
}
// Data Shortcode
$show = get_option( 'ysd-mapi_single_show_data', true );
if ( true == $show ) {
    add_action( 'mapi_property_main', array( 'YSD_Mapi_Property_Data_Shortcode', 'mapi_property_data_shortcode' ), 20 );
}
// Map Shortcode
$show = get_option( 'ysd-mapi_single_show_map', true );
if ( true == $show ) {
    add_action( 'mapi_property_after_wrapper', array( 'YSD_Mapi_Property_Map_Shortcode', 'mapi_property_map_shortcode_add' ), 15 );
}
// Contact Shortcode
$show = get_option( 'ysd-mapi_single_show_contact', true );
if ( true == $show ) {
    add_action( 'mapi_property_side', array( 'YSD_Mapi_Property_Contact_Shortcode', 'mapi_property_contact_shortcode' ), 10 );
}
// Footer Shortcode
$show = get_option( 'ysd-mapi_single_show_footer', true );
if ( true == $show ) {
    add_action( 'mapi_property_footer', array( 'YSD_Mapi_Property_Footer_Shortcode', 'mapi_property_footer_shortcode' ), 10 );
}

/**
 * Single - Components (Functions)
 */
add_action( 'mapi_property_side', 'mapi_single_side_sidebar', 20 );
add_action( 'mapi_property_alternative_content', 'mapi_single_alternative_content', 10 );