<?php 

if ( ! class_exists( 'YSD_Mapi_Property_Shortcodes' ) ) {
    /*
    * Shortcode icons map/floorplan/brochure/share/print/favorite
    */
    class YSD_Mapi_Property_Shortcodes{
        public function __construct(){
            add_shortcode( 'mapi_map_link', array( $this, 'mapi_map_link_shortcode' ));
            add_shortcode( 'mapi_floorplan_link', array( $this, 'mapi_floorplan_link_shortcode' ));
            add_shortcode( 'mapi_brochure', array( $this, 'mapi_brochure_shortcode' ));
            add_shortcode( 'mapi_share', array( $this, 'mapi_share_shortcode'));
            add_shortcode( 'mapi_print', array( $this, 'mapi_print_shortcode'));
            add_shortcode( 'mapi_favorite', array( $this, 'mapi_favorite_shortcode'));

        }

        public function mapi_map_link_shortcode($atts){
            $atts = shortcode_atts(
                array(
                    'class'         => '',
                ),
                $atts
            );

            $post_id = get_the_ID();
            $property = get_post($post_id);
            $button = '';
            $shortcode = '[mapi_property_map]';

            // Map Button | Check if map shortocde is used
            if ( stripos($property->post_content, $shortcode) ) {
                $button .= sprintf(
                    '<a class="property-gallery__button property-gallery__button--map" href="#propertyMap">%s</a>',
                    __( 'Map', YSD_MAPI_TEXT_DOMAIN )
                );
            }

            return $button;
        }

        public function mapi_floorplan_link_shortcode($atts){
            $atts = shortcode_atts(
                array(
                    'class'         => '',
                ),
                $atts
            );
            
            $post_id = get_queried_object_id();
            $images_args = array (
                'post_parent' => $post_id,
                'post_type' => 'attachment',
                'numberposts' => -1, // get all
                'post_status' => 'any',
                'post_mime_type' => 'image',
                'orderby' => 'date',
                'order' => 'ASC',
            );

            $button = '';
            $images = get_posts( $images_args );

            //Check if media has a floorplan
            foreach ($images as $image){
                if($image->post_excerpt == 'SOURCE_PROPERTY_FLOORPLAN'){
                    $floorplan = $image->guid;
                }
            }

            // Floorplan Button | Show floorplan button | Show floorplan
            if ( $floorplan ) {
                $button .= sprintf(
                    '<a id="property-gallery__floorplan" class="property-gallery__button property-gallery__button--plan" >%s</a>',
                    __( 'Floorplan', YSD_MAPI_TEXT_DOMAIN ),
                );
            }

            return $button;
        }

        public function mapi_brochure_shortcode($atts){
            $atts = shortcode_atts(
                array(
                    'class'         => '',
                ),
                $atts
            );

            $button = '';
            $post_id = get_queried_object_id();

            $images_args = array (
                'post_parent' => $post_id,
                'post_type' => 'attachment',
                'numberposts' => -1, // get all
                'post_status' => 'any',
                'orderby' => 'date',
                'order' => 'ASC',
            );

            $medias = get_posts( $images_args );
            $brochure_url = get_post_meta($post_id, 'brochure_url', true);

            //Check if has a brochure
            foreach ($medias as $media){
                if($media->post_excerpt == 'SOURCE_PROPERTY_DOCUMENT'){
                    $brochure = $media->guid;
                }
            }

            // Brochure Button | Show brochure
            if( !empty($brochure) && empty($brochure_url) || !empty($brochure) && !empty($brochure_url) ) {
                $button .= sprintf(
                    '<a class="property-gallery__button property-gallery__button--brochure" href="%s" target="_blank">%s</a>',
                    esc_url($brochure),
                    __( 'Brochure', YSD_MAPI_TEXT_DOMAIN )
                );
            }

            if( !empty($brochure_url) && empty($brochure) ) {
                $button .= sprintf(
                    '<a class="property-gallery__button property-gallery__button--brochure" href="%s" target="_blank">%s</a>',
                    esc_url($brochure_url),
                    __( 'Brochure', YSD_MAPI_TEXT_DOMAIN )
                );
            }

            return $button;
        }

        public function mapi_share_shortcode($atts){
            $atts = shortcode_atts(
                array(
                    'class'         => '',
                ),
                $atts
            );

            $button = '';
            $popup = '';

            // Add social buttons shortcode to variable
            ob_start();
            $popup .= do_shortcode( '[ysp_socialbtns]' );
            $popup .= ob_get_clean();
            ob_get_contents();

            // Add shortcode below the share button
            $button .= sprintf(
                '<button id="socialBtnsDropdown" class="property-gallery__button property-gallery__button--share">%s</button><div id="socialBtns" style="display:none;" class="property-share__dropdown">%s</div>',
                __( 'Share', YSD_MAPI_TEXT_DOMAIN ),
                $popup
            );
           
            return $button;
        }

        public function mapi_print_shortcode($atts){
            $atts = shortcode_atts(
                array(
                    'class'         => '',
                ),
                $atts
            );

            $button = '';

            // Print button
            $button .= sprintf(
                '<a class="property-gallery__button property-gallery__button--print" id="printCurrentPage">%s</a>',
                __( 'Print', YSD_MAPI_TEXT_DOMAIN )
            );
            
            $post_id = get_queried_object_id();
            $property = get_post($post_id);
    
            // Price (Formatted/Locale)
            $price = getFormattedLocalePrice( $property );
            $price = (!empty($property)) ? $price : '';
             
            // Sale Condition
            $sale_condition = getPropertySaleCondition( $property );
            $sale_condition = (!empty($sale_condition)) ? $sale_condition : '';

            // Status
            $sale_status = getPropertySaleStatus( $property, true );
            if ( empty($sale_status) ) {
                return;
            }

            $status = !empty($sale_status) ? $sale_status['value'] : '';

            // The content of the post
            $post_content = $property->post_content;
            $content = !empty($post_content) ? apply_filters( 'the_content', $post_content ) : '';
            
            // Get all images
            $images_args = array (
                'post_parent' => $post_id,
                'post_type' => 'attachment',
                'numberposts' => -1, 
                'post_status' => 'any',
                'post_mime_type' => 'image',
                'orderby' => 'date',
                'order' => 'ASC',
            );
            $images = get_posts( $images_args );
            $images_array = array_values( $images );
            $count = count( $images );
            $image_args = array( 'class' => 'property-gallery__image' );

            // Show the first image
            for ( $x = 0; $x < 1; $x++ ) {
                $image_id = $images_array[ $x ]->ID;
            }

            // Get the data from the tables
            $data_tables = new YSD_Mapi_Property_Data_Tables();

            $accountmanager = get_post_meta($property->ID, 'accountmanager', true);

            $args = array(
                'post_type' => 'employee',
                'posts_per_page' => -1,
                'meta_query' => array(
                    array(
                        'key' => 'accountmanager',
                        'value' => $accountmanager,
                        'compare' => '=',
                    ),
                    array(
                        'key' => 'accountmanager',
                        'value' => '',
                        'compare' => '!=',
                    ),
                ),
            );
            $query = new WP_Query($args);

            $employees = $query->get_posts();
            if ( isset( $employees[0] ) ) {
                $employee = $employees[0];
                $name = $employee->post_title;
                $position = get_post_meta($employee->ID, '_employee_position', true);
                $phone = get_post_meta($employee->ID, '_employee_phone_number', true);
                $email = get_post_meta($employee->ID, '_employee_email_address', true);
            }

            
            ?>
            
            <!-- Print template -->
            <div id="printPage" style="display: none;" class="c-container c-container--wide">
                <?php do_action( 'mapi_print_css' ); ?>
                <section class="print-header">
                    <div class="print-property--image" data-image-id="<?php echo $image_id ?>"> <?php echo wp_get_attachment_image( $image_id, 'wps_child_masonry_large', false, $image_args ) ?></div>
                    <div class="print-property--place">
                        <span class="print-property--zipcode"><?php echo $property->zipcode ?> </span><span class="print-property--city" ><?php echo $property->city ?></span>
                    </div>
                    <div class="print-property--address">
                        <span><?php echo $property->address_1 ?></span><span> <?php echo $property->house_number ?></span><span> <?php echo $property->house_number_addition ?></span>
                    </div>
                    <span class="print-property--price"><?php echo $price ?></span><span class="print-property--sale-condition"> <?php echo $sale_condition ?></span>
                    <span class="print-property--status"><?php echo $status ?></span>
                </section>
    
                <section class="print-content">
                    <h2 class="property-section-title"><?php echo __( 'Description', YSD_MAPI_TEXT_DOMAIN ) ?></h2>
                    <div><?php echo $content?></div>
                </section>

                <section class="print-data">
                    <h2 class="property-section-title"><?php echo __( 'Features', YSD_MAPI_TEXT_DOMAIN ) ?></h2>
                    <div><?php echo $data_tables->init(); ?></div>
                </section>
                <?php 
                    if($employee){ ?>
                        <section class="print-employee">
                            <h2 class="property-section-title"><?php echo __( 'Employee', YSD_MAPI_TEXT_DOMAIN ) ?></h2>
                            <div class="print-employee-div">
                                <span class="print-employee--name"><?php echo $name ?></span>
                                <span class="print-employee--position"><?php echo $position ?></span>
                                <span class="print-employee--phone"><?php echo $phone ?></span>
                                <span class="print-employee--email"><?php echo $email ?></span>
                            </div>
                        </section>
                    <?php }
                ?>
                <section class="print-images">
                    <h2 class="property-section-title"><?php echo __( 'Images', YSD_MAPI_TEXT_DOMAIN ) ?></h2>
                    <?php 
                        for ($i=0; $i < $count; $i++) { 
                            $all_images = $images_array[ $i ]->ID;
                            ?><div data-image-id="<?php echo $all_images ?>"><?php echo wp_get_attachment_image( $all_images, 'mapi_medium', false, $image_args ) ?></div><?php
                        }
                    ?>
                </section>
             </div>
            
            <?php

            return $button;

        }

        public function mapi_favorite_shortcode($atts){
            $atts = shortcode_atts(
                array(
                    'class'         => '',
                ),
                $atts,
            );

            $button = '';

            // Favorite button
            $button .= sprintf(
                '<button id="favorite" class="property-gallery__button property-gallery__button--unlike">%s</button>',
                __( 'Favorite', YSD_MAPI_TEXT_DOMAIN )
            );
           
            return $button;
        }
        
    }
}
new YSD_Mapi_Property_Shortcodes();