<?php

if ( ! class_exists( 'Mapi_Property_Filter_Result_Count' ) ) {

    class Mapi_Property_Filter_Result_Count {

        public function __construct() {
            $this->property_filter_result_count();
        }
        
        /*
         * Property Filter Result Count
         */
        public function property_filter_result_count() {

            if ( true != get_option( 'ysd-mapi_archive_display_filter_result_count', true) ) {
                return;
            }
            ?>

            <div class="c-property-result-count">
                <?php

                    if ( class_exists( 'Mapi_Property_Query' ) ) {
                        $custom_query = Mapi_Property_Query::init();
                    }
                    
                    // Settings & Variables
                    $ppp_def  = get_option( 'ysd-mapi_archive_properties_per_page', 10 );
                    $get_ppp  = (isset($_GET['posts_per_page'])) ? $_GET['posts_per_page'] : $ppp_def;
                    $current  = max( 1, get_query_var( 'paged' ) );
                    $paged    = max( 1, $custom_query->max_num_pages );
                    $per_page = intval($get_ppp);
                    $total    = $custom_query->found_posts;
                    $first    = ( $per_page * $paged ) - $per_page + 1;
                    $last     = min( $total, $get_ppp * $paged );

                    if ( 0 ===  intval($total) ) {
                        _e( 'No results', 'ysd-mapi' );
                    } elseif ( 1 ===  intval($total) ) {
                        _e( 'Showing the single result', 'ysd-mapi' );
                    } elseif ( $total <= $per_page || -1 == $per_page ) {
                        /* translators: %d: total results */
                        printf( _n( 'Showing all %d result', 'Showing all %d results', $total, 'ysd-mapi' ), $total );
                    } else {
                        $first = ( $per_page * $current ) - $per_page + 1;
                        $last  = min( $total, $per_page * $current );
                        /* translators: 1: first result 2: last result 3: total results */
                        printf( _nx( 'Showing %1$d&ndash;%2$d of %3$d result', 'Showing %1$d&ndash;%2$d of %3$d results', $total, 'with first and last result', 'ysd-mapi' ), $first, $last, $total );
                    }
                ?>
            </div>

            <?php
        }

    }

}