<?php

if ( ! class_exists( 'Mapi_Property_Filter_Values' ) ) {

    class Mapi_Property_Filter_Values {

        public function __construct() {
            $this->property_filter_values();
        }

        /*
         * Make buttons for the filter values
         */
        public function getFilterValues() {
            // Create variable button
            $button = [];

            // Loop over all get variables -> these are the filters
            foreach ( $_GET as $key => $value ) {

                // Only go through when its not a minmax (array) filter, when there is value and when its not the ordering
                // The ordering does not get a button
                // Minmax filters will get formatting later
                if ( ! empty( $value ) && ! is_array( $value ) && $key != 'lang' ) {

                    // Add key for the sale_status button for clarification
                    if ($key == 'sale_status') {
                        $value = explode( ',', $value );
                        foreach ($value as $status) {
                            switch ($status) {
                                case '1':
                                    $new = [
                                        'name' => 'sale_status',
                                        'value' => __('For sale', YSD_MAPI_TEXT_DOMAIN),
                                    ];
                                    break;
                                case '2':
                                    $new = [
                                        'name' => 'sale_status',
                                        'value' => __('For rent', YSD_MAPI_TEXT_DOMAIN),
                                    ];
                                    break;
                                case '3':
                                    $new = [
                                        'name' => 'sale_status',
                                        'value' => __('Under offer', YSD_MAPI_TEXT_DOMAIN),
                                    ];
                                    break;
                                case '4':
                                    $new = [
                                        'name' => 'sale_status',
                                        'value' => __('Sold STC', YSD_MAPI_TEXT_DOMAIN),
                                    ];
                                    break;
                                case '5':
                                    $new = [
                                        'name' => 'sale_status',
                                        'value' => __('Rented STC', YSD_MAPI_TEXT_DOMAIN),
                                    ];
                                    break;
                                case '6':
                                    $new = [
                                        'name' => 'sale_status',
                                        'value' => __('Sold', YSD_MAPI_TEXT_DOMAIN),
                                    ];
                                    break;
                                case '7':
                                    $new = [
                                        'name' => 'sale_status',
                                        'value' => __('Rented', YSD_MAPI_TEXT_DOMAIN),
                                    ];
                                    break;
                                case '8':
                                    $new = [
                                        'name' => 'sale_status',
                                        'value' => __('Purchased', YSD_MAPI_TEXT_DOMAIN),
                                    ];
                                    break;
                                case '9':
                                    $new = [
                                        'name' => 'sale_status',
                                        'value' => __('Withdrawn', YSD_MAPI_TEXT_DOMAIN),
                                    ];
                                    break;
                            }
                            $button[] = $new;
                        }
                        unset($value); // Unset initial value
                    }

                    // Add key for the sale_type button for clarification
                    if ($key == 'sale_type') {
                        $value = ( '2' == $value ) ? __( 'Rent', YSD_MAPI_TEXT_DOMAIN ) : __( 'Buy', YSD_MAPI_TEXT_DOMAIN );
                    }

                    // Add key for the posts_per_page button for clarification
                    if ($key == 'posts_per_page') {
                        // $value = $value . '+ ' . __( 'properties', YSD_MAPI_TEXT_DOMAIN );
                        $value = '';
                    }

                    // Add key for the orderby button for clarification
                    if ($key == 'orderby') {
                        // switch ($value) {
                        //     case 'date:desc':
                        //         $value = __( 'Date (descending)', YSD_MAPI_TEXT_DOMAIN );
                        //         break;
                        //     case 'date:asc':
                        //         $value = __( 'Date (ascending)', YSD_MAPI_TEXT_DOMAIN );
                        //         break;
                        //     case 'sale_status:desc':
                        //         $value = __( 'Status (descending)', YSD_MAPI_TEXT_DOMAIN );
                        //         break;
                        //     case 'sale_status:asc':
                        //         $value = __( 'Status (ascending)', YSD_MAPI_TEXT_DOMAIN );
                        //         break;
                        //     case 'price:desc':
                        //         $value = __( 'Price (descending)', YSD_MAPI_TEXT_DOMAIN );
                        //         break;
                        //     case 'price:asc':
                        //         $value = __( 'Price (ascending)', YSD_MAPI_TEXT_DOMAIN );
                        //         break;
                        //     default:
                        //         $value = str_replace( ':', ' ', $value );
                        //         $value = str_replace( 'asc', ' '. __( '(ascending)', YSD_MAPI_TEXT_DOMAIN ), $value );
                        //         $value = str_replace( 'desc', ' '. __( '(descending)', YSD_MAPI_TEXT_DOMAIN ), $value );
                        // }
                        $value = '';
                    }

                    // Add key for the number_of_bedrooms button for clarification
                    if ($key == 'number_of_bedrooms') {
                        $value = $value . '+ ' . __( 'bedrooms', YSD_MAPI_TEXT_DOMAIN );
                    }

                    // Add key for the number_of_rooms button for clarification
                    if ($key == 'number_of_rooms') {
                        $value = $value . '+ ' . __( 'rooms', YSD_MAPI_TEXT_DOMAIN );
                    }

                    // Format the value of these filters to the desired way
                    if ($key == 'usable_area' || $key == 'plot_area') {
                        $value = str_replace('msup2', '', $value);
                        $value = $value . '+ m&sup2;';
                    }

                    // Add values to the output array
                    if ( !empty( $value ) ) {
                        $new = [
                            'name' => $key,
                            'value' => $value,
                        ];
                        $button[] = $new;
                    }

                // Only go through if it is the minmax dropdown filter
                } else if ( is_array( $value ) ) {

                    // Volume Unit
                    $volume_unit = get_option( 'ysd-mapi_realtor_property_unit', 'metric' );
                    $volume_unit = ( 'imperial' === $volume_unit ) ? 'f' :  'm';

                    foreach ( $value as $minmax => $val ) {

                        // Check if there is a value
                        if ( ! empty( $val ) ) {
                            
                            // Add values to the output array
                            if ( 'price' == $key ) {
                                $val = is_numeric($val) ? number_format($val, 0, ',', '.') : $val;
                                $new = [
                                    'name' => 'price[' . $minmax . ']',
                                    'value' => ucfirst($minmax) . ' €' . $val,
                                ];
                            } else if ( 'usable_area' == $key || 'plot_area' == $key ) {
                                $val = is_numeric($val) ? number_format($val, 0, ',', '.') : $val;
                                $new = [
                                    'name' => $key .'[' . $minmax . ']',
                                    'value' => ucfirst($minmax) . ' ' . $val . $volume_unit .'²',
                                ];
                            } else if ( 'volume_area' == $key ) {
                                $val = is_numeric($val) ? number_format($val, 0, ',', '.') : $val;
                                $new = [
                                    'name' => 'volume_area[' . $minmax . ']',
                                    'value' => ucfirst($minmax) . ' ' . $val . $volume_unit .'³',
                                ];
                            } else {
                                $new = [
                                    'name' => $key .'[' . $minmax . ']',
                                    'value' => ucfirst($minmax) . $val,
                                ];
                            }

                            $button[] = $new;
                        }

                    }
                }
            }

            // Return array of filters
            return $button;
        }
        
        /*
         * Property Filter values
         */
        public function property_filter_values() {
            $getFilterValues = $this->getFilterValues();
            ?>

            <?php if ( ! empty( $getFilterValues ) && is_array( $getFilterValues ) ): ?>
                <div class="c-filter-values clearfix">
                    <div class="c-filter-values__inner">
                        <?php foreach ( $getFilterValues as $button ): ?>
                            <div class="c-filter-values__item" name="<?= $button['name'] ?>">
                                <span class="c-filter-values__remove-cross"></span>
                                <span><?= $button['value']; ?></span>
                            </div>
                        <?php endforeach; ?>
                    </div>
                    <div class="c-filter-values__remover">
                        <div id="removeAllFilterValues" class="c-filter-values__item c-filter-values__remover-btn" type="text">
                            <span class="c-filter-values__remove-cross"></span>
                            <span><?php _e( 'Clear all filters', YSD_MAPI_TEXT_DOMAIN ); ?></span>
                        </div>
                    </div>
                </div>
            <?php endif ?>

            <?php
        }

    }

}