<?php

if ( ! class_exists( 'Mapi_Property_Pagination' ) ) {

    class Mapi_Property_Pagination {

        public function __construct($custom_query = '') {
            $this->property_pagination = $custom_query;
        }
        
        /*
         * Property Pagination
         */
        public function property_pagination() {
        
            $max_num_pages = $this->property_pagination;
            if ( empty( $max_num_pages ) ) {
                return;
            }
            
            $big = 999999999;
            $chevron_prev = '<span class="c-property-pagination__icon"><svg aria-hidden="true" focusable="false" data-prefix="far" data-icon="chevron-left" class="svg-inline--fa fa-chevron-left fa-w-8" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 256 512"><path fill="currentColor" d="M231.293 473.899l19.799-19.799c4.686-4.686 4.686-12.284 0-16.971L70.393 256 251.092 74.87c4.686-4.686 4.686-12.284 0-16.971L231.293 38.1c-4.686-4.686-12.284-4.686-16.971 0L4.908 247.515c-4.686 4.686-4.686 12.284 0 16.971L214.322 473.9c4.687 4.686 12.285 4.686 16.971-.001z"></path></svg></span>';
            $chevron_next = '<span class="c-property-pagination__icon"><svg aria-hidden="true" focusable="false" data-prefix="far" data-icon="chevron-right" class="svg-inline--fa fa-chevron-right fa-w-8" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 256 512"><path fill="currentColor" d="M24.707 38.101L4.908 57.899c-4.686 4.686-4.686 12.284 0 16.971L185.607 256 4.908 437.13c-4.686 4.686-4.686 12.284 0 16.971L24.707 473.9c4.686 4.686 12.284 4.686 16.971 0l209.414-209.414c4.686-4.686 4.686-12.284 0-16.971L41.678 38.101c-4.687-4.687-12.285-4.687-16.971 0z"></path></svg></span>';

            $links = paginate_links(array(
                'base' => str_replace( array($big, '#038;'), array('%#%', ''), esc_url(get_pagenum_link($big))),
                'format' => '?page=%#%',
                'current' => max(1, get_query_var('paged')),
                'total' => $max_num_pages,
                'type' => 'array',
                'mid_size' => 1,
                'prev_text' => $chevron_prev .'<span>'. __( 'Previous' ) .'</span>',
                'next_text' => '<span>'. __( 'Next' ) .'</span>'. $chevron_next
            ));
            
            $output = '';
            if ( is_array( $links ) ) {
                $output .= '<nav aria-label="'. __('Page navigation', YSD_MAPI_TEXT_DOMAIN) .'">';
                    $output .= '<ul class="c-property-pagination">';
                    foreach ( $links as $count => $link ) {

                        $link = preg_replace('/page-numbers/', 'c-property-pagination__link'  , $link);
                        $link = preg_replace('/prev/', 'c-property-pagination__prev' , $link);
                        $link = preg_replace('/next/', 'c-property-pagination__next'  , $link);
                        $link = preg_replace('/current/', 'c-property-pagination__current'  , $link);
                        $link = preg_replace('/aria-c-property-pagination__current/', 'aria-current'  , $link);

                        $is_prev = strpos( $link, 'prev' ) != '' ? ' c-property-pagination__prev' : '';
                        $is_next = strpos( $link, 'next' ) != '' ? ' c-property-pagination__next' : '';

                        $output .= '<li class="c-property-pagination__item'. $is_prev . $is_next .'" data-count="'. $count .'">'. $link .'</li>';
                    }
                    $output .= '</ul>';
                $output .= '</nav>';
            }

            echo '<div class="property-pagination">'. $output .'</div>';

        }

    }

}