<?php

if ( ! class_exists( 'YSD_Mapi_Property_Contact_Shortcode' ) ) {

    class YSD_Mapi_Property_Contact_Shortcode {

        private static $addModal = false;

        public function __construct() {
            add_shortcode( 'mapi_property_contact', array( $this, 'mapi_property_contact_shortcode' ) );
            add_action( 'wp_footer', array( $this, 'add_contact_modal' ) );
            add_action( 'wp_enqueue_scripts', array( $this, 'add_contact_modal_script' ) );
        }
        
        /*
        * Property Contact
        */
        public static function mapi_property_contact_shortcode($atts) {
            $options = shortcode_atts(
                array(
                    'title' => '',
                    'label' => '',
                    'class' => '',
                    // 'employee' => '',
                ),
                $atts
            );

            session_start();
            $standard_employee = $_SESSION['standard_employee'];

            // Enable/disable
            $enabled = get_option( 'ysd-mapi_single_contact_widget', true );
            if ( true != $enabled ) {
                return;
            }

            self::$addModal = true;

            $output = '';

            $post_id = get_queried_object_id();
            $post = get_post( $post_id );
            $accountmanager = get_post_meta($post->ID, 'accountmanager', true);

            $args = array(
                'post_type' => 'employee',
                'posts_per_page' => -1,
                'meta_query' => array(
                    array(
                        'key' => 'accountmanager',
                        'value' => $accountmanager,
                        'compare' => '=',
                    ),
                    array(
                        'key' => 'accountmanager',
                        'value' => '',
                        'compare' => '!=',
                    ),
                ),
            );
            $query = new WP_Query($args);

            $employees = $query->get_posts();

            // Get the first employee of the employee list
            $args_empty = array(
                'post_type' => 'employee',
                'posts_per_page' => 1,
            );
            $query_empty = new WP_Query($args_empty);
            $employee_empty = $query_empty->get_posts();

            if ( isset( $employees[0] ) || empty($employees) && $standard_employee == 'yes') {
                if(isset( $employees[0] )){
                    $employee = $employees[0];
                }

                if($standard_employee == 'yes' && empty($employees)){
                    $employee = $employee_empty[0];
                }

                $title = $options['title'] ? $options['title'] : __( 'Interested or any questions?', YSD_MAPI_TEXT_DOMAIN );
                $label = $options['label'] ? $options['label'] : __( 'Contact us', YSD_MAPI_TEXT_DOMAIN );
                $name = $employee->post_title;
                $position = get_post_meta($employee->ID, '_employee_position', true);
                $phone = get_post_meta($employee->ID, '_employee_phone_number', true);
                $email = get_post_meta($employee->ID, '_employee_email_address', true);
                $thumbnail = wp_get_attachment_image(get_post_thumbnail_id($employee->ID));

                $class = get_option( 'ysd-mapi_single_contact_widget_btn_class' );
                $class = (!empty($class)) ? $class : 'c-button c-button--color-1 property-contact-reply';

                $option = get_option('ysd-mapi_single_contact_widget_action');
                $contact_modal = !empty($option['modal']) ? $option['modal'] : '';
                $contact_page = !empty($option['page']) ? $option['page'] : '';
                $contact_page_target = !empty($option['page_target']) ? ' target="'. $option['page_target'] .'"' : ' target="_blank"';

                $output = '';
                $output .= '<div class="property-contact">';
                    $output .= '<div class="property-contact-header">';
                        $output .= '<h2 class="property-contact-header-title">'. $title .'</h2>';
                    $output .= '</div>';
                    
                    $output .= '<div class="property-contact-content">';
                        if( !empty($thumbnail) ) {
                            $output .= '<div class="property-contact-thumb-area">';
                                $output .= '<div class="property-contact-thumb">' . $thumbnail . '</div>';
                            $output .= '</div>';
                        }

                        if ( ! empty( $position ) || ! empty( $phone ) || ! empty( $email ) || !empty( $name ) ) {
                            $output .= '<div class="property-contact-info">';
                            if(!empty($name)) {
                                $output .= '<div class="property-contact-name">'. $name .'</div>';
                            }
                            if ( ! empty( $position ) ) {
                                $output .= '<div class="property-contact-position">'. $position .'</div>';
                            }
                            if ( ! empty( $phone ) ) {
                                $output .= '<a class="property-contact-phone" href="tel:'. $phone .'">'. $phone .'</a>';
                            }
                            if ( ! empty( $email ) ) {
                                $output .= '<a class="property-contact-email" href="mailto:'. $email .'">'. $email .'</a>';
                            }
                            $output .= '</div>';
                        }
                        if(isset($option['type']) && $option['type'] != 'hide' && ( $contact_modal || $contact_page ))
                        {
                            $output .= '<div class="property-contact-actions">';
                                if(isset($option['type']) && $option['type'] == 'modal')
                                {
                                    $output .= '<button id="openModalPAV" class="'. $class .'">'. $label .'</button>';
                                }
                                else if (isset($option['type']) && $option['type'] == 'page')
                                {
                                    $output .= '<a href="' . $contact_page . '" class="'. $class .'"'. $contact_page_target .'>'. $label .'</a>';
                                }
                            $output .= '</div>';
                        }
                    $output .= '</div>';

                $output .= '</div>';

            }

            $templatera = get_option( 'ysd-mapi_single_template_hooks' );
            if ( 'disabled' != $templatera ) {
                echo $output;
            } else {
                return $output;
            }

        }
        
        /*
        * Property Contact Modal
        */
        public function add_contact_modal() {
            if(!self::$addModal) {
                return false;
            }

            $output = '';

            $formShortcode = get_option('ysd-mapi_single_contact_widget_action')['content'] ?? '';
            
            if ( empty($formShortcode) ) {
                return;
            }

            // Enqueue Script
            wp_enqueue_script( 'mapi-property-contact-modal-script' );
            
            $output .= '<div id="pavModal" class="c-pav-modal-inner">';
                $output .= '<div id="pavModalContent" class="c-pav-modal-content">';
                    $output .= '<span class="pav-close">&times;</span>';
                    $output .= '<div>'. do_shortcode( $formShortcode ) .'</div>';
                $output .= '</div>';
            $output .= '</div>';
            $output .= '<div id="pavModalOverlay" class="c-pav-modal-overlay"></div>';

            $output = '<div class="c-pav-modal">'. $output .'</div>';

            echo $output;
        }

        /**
         * Property Contact Modal Script
         */
        public function add_contact_modal_script() {

            wp_register_script( 'mapi-property-contact-modal-script', YSD_MAPI_PLUGIN_URL . 'front/assets/src/js/components/property-contact-modal.js', array( 'jquery' ), '1.0.0', true );

            $submit_class = get_option('ysd-mapi_single_contact_widget_action_submit_class');
            $submit_class = !empty($submit_class) ? explode(" ", $submit_class) : '';
            $contactData = array(
                'submitClass' => $submit_class,
            );
            wp_localize_script( 'mapi-property-contact-modal-script', 'contactModalData', $contactData );

        }

    }

}
new YSD_Mapi_Property_Contact_Shortcode();