<?php

if ( ! class_exists( 'YSD_Mapi_Property_Description_Shortcode' ) ) {

    class YSD_Mapi_Property_Description_Shortcode {

        public function __construct() {
            add_shortcode( 'mapi_property_description', array( $this, 'mapi_property_description_shortcode' ) );
        }
        
        /*
        * Property Description
        */
        public static function mapi_property_description_shortcode($atts) {
            $options = shortcode_atts(
                array(
                    'class'         => '',
                ),
                $atts
            );

            $output = '';
            
            $post_id = get_queried_object_id();
            $post = get_post($post_id);
            if ( empty( $post ) ) {
                return;
            }

            $title = '<h2 class="property-section-title">' . __( 'Description', YSD_MAPI_TEXT_DOMAIN ) . '</h2>';
            $post_content = $post->post_content;
            $content = !empty($post_content) ? apply_filters( 'the_content', $post_content ) : '';
            $label_more = '<span class="read-more-label">'. __('Read more', YSD_MAPI_TEXT_DOMAIN) .'</span>';
            $label_less = '<span class="read-close-label">'. __('Read less', YSD_MAPI_TEXT_DOMAIN) .'</span>';

            $class = get_option( 'ysd-mapi_single_desc_btn_class' );
            $class = (!empty($class)) ? ' '. $class : ' c-button c-button--color-1 c-button--sm';

            $output = sprintf(
                '<section class="property-section property-description"><input type="checkbox" class="property-read-more-state" id="property-read-more-toggle"/>%s<div class="property-content">%s</div><label for="property-read-more-toggle" class="property-read-more-trigger'. $class .'">%s%s</label></section>',
                $title,
                $content,
                $label_more,
                $label_less
            );

            $templatera = get_option( 'ysd-mapi_single_template_hooks' );
            if ( 'disabled' != $templatera ) {
                echo $output;
            } else {
                return $output;
            }

        }

    }

}
new YSD_Mapi_Property_Description_Shortcode();