<?php

if ( ! class_exists( 'YSD_Mapi_Property_Gallery_Compact_Shortcode ')){

    class YSD_Mapi_Property_Gallery_Compact_Shortcode {

        public function __construct(){
            add_shortcode('mapi_property_gallery_compact', array($this, 'mapi_property_gallery_compact_shortcode'));
        }

        /*
        * Property Gallery Compact
        */

        public function mapi_property_gallery_compact_shortcode($atts){
            $$options = shortcode_atts(
                array(
                    'class'         => '',
                ),
                $atts
            );

            $output = '';

            $post_id = get_queried_object_id();

            $images_args = array (
                'post_parent' => $post_id,
                'post_type' => 'attachment',
                'numberposts' => -1, // get all
                'post_status' => 'any',
                // 'post_mime_type' => 'image',
                'orderby' => 'date',
                'order' => 'ASC',
            );
            
            // Get attachments
            $images = get_posts( $images_args );
            $video_url = get_post_meta( $post_id, 'video_url', true );

            // Declare variables
            $image_list         =   '';
            $button             =   '';
            $degrees_360        =   0;
            $total              =   count( $images );
	        $images_array       =   array_values( $images );
            $has_video_url      =   !empty($video_url) ?? $video_url;
            $image_args         =   array( 'class' => 'property-gallery__image' );
            
            foreach ($images as $image){
                if($image->post_excerpt == 'SOURCE_PROPERTY_FLOORPLAN'){
                    $floorplan = $image->guid;
                }
                if($image->post_excerpt == 'SOURCE_PROPERTY_VIDEO'){
                    $video = $image->guid;
                }
            }
            
            // Play icon
            $iconPlay = '<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="play-circle" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" class="svg-inline--fa fa-play-circle fa-w-16"><path fill="currentColor" d="M256 504c137 0 248-111 248-248S393 8 256 8 8 119 8 256s111 248 248 248zM40 256c0-118.7 96.1-216 216-216 118.7 0 216 96.1 216 216 0 118.7-96.1 216-216 216-118.7 0-216-96.1-216-216zm331.7-18l-176-107c-15.8-8.8-35.7 2.5-35.7 21v208c0 18.4 19.8 29.8 35.7 21l176-101c16.4-9.1 16.4-32.8 0-42zM192 335.8V176.9c0-4.7 5.1-7.6 9.1-5.1l134.5 81.7c3.9 2.4 3.8 8.1-.1 10.3L201 341c-4 2.3-9-.6-9-5.2z" class=""></path></svg>';
            $iconImages = '<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="images" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512" class="svg-inline--fa fa-images fa-w-16"><path fill="currentColor" d="M464 448H96c-35.35 0-64-28.65-64-64V112C32 103.2 24.84 96 16 96S0 103.2 0 112V384c0 53.02 42.98 96 96 96h368c8.836 0 16-7.164 16-16S472.8 448 464 448zM224 152c13.26 0 24-10.75 24-24s-10.74-24-24-24c-13.25 0-24 10.75-24 24S210.8 152 224 152zM410.6 139.9c-11.28-15.81-38.5-15.94-49.1-.0313l-44.03 61.43l-6.969-8.941c-11.44-14.46-36.97-14.56-48.4 .0313L198.2 272.8C191 281.9 190 294.3 195.5 304.3C200.8 313.1 211.1 320 222.4 320h259.2c11 0 21.17-5.805 26.54-15.09c0-.0313-.0313 .0313 0 0c5.656-9.883 5.078-21.84-1.578-31.15L410.6 139.9zM226.2 287.9l58.25-75.61l20.09 25.66c4.348 5.545 17.6 10.65 25.59-.5332l54.44-78.75l92.68 129.2H226.2zM512 32H160c-35.35 0-64 28.65-64 64v224c0 35.35 28.65 64 64 64H512c35.35 0 64-28.65 64-64V96C576 60.65 547.3 32 512 32zM544 320c0 17.64-14.36 32-32 32H160c-17.64 0-32-14.36-32-32V96c0-17.64 14.36-32 32-32h352c17.64 0 32 14.36 32 32V320z"/></svg>';
            $iconFloorplan = '<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="vector square" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512" class="svg-inline--fa fa-vector-square fa-w-16"><path d="M408 32C430.1 32 448 49.91 448 72V120C448 142.1 430.1 160 408 160H400V352H408C430.1 352 448 369.9 448 392V440C448 462.1 430.1 480 408 480H360C337.9 480 320 462.1 320 440V432H128V440C128 462.1 110.1 480 88 480H40C17.91 480 0 462.1 0 440V392C0 369.9 17.91 352 40 352H48V160H40C17.91 160 0 142.1 0 120V72C0 49.91 17.91 32 40 32H88C110.1 32 128 49.91 128 72V80H320V72C320 49.91 337.9 32 360 32H408zM408 64H360C355.6 64 352 67.58 352 72V120C352 124.4 355.6 128 360 128H408C412.4 128 416 124.4 416 120V72C416 67.58 412.4 64 408 64zM80 352H88C110.1 352 128 369.9 128 392V400H320V392C320 369.9 337.9 352 360 352H368V160H360C337.9 160 320 142.1 320 120V112H128V120C128 142.1 110.1 160 88 160H80V352zM32 392V440C32 444.4 35.58 448 40 448H88C92.42 448 96 444.4 96 440V392C96 387.6 92.42 384 88 384H40C35.58 384 32 387.6 32 392zM352 392V440C352 444.4 355.6 448 360 448H408C412.4 448 416 444.4 416 440V392C416 387.6 412.4 384 408 384H360C355.6 384 352 387.6 352 392zM32 72V120C32 124.4 35.58 128 40 128H88C92.42 128 96 124.4 96 120V72C96 67.58 92.42 64 88 64H40C35.58 64 32 67.58 32 72z"/></svg>';
           
            for ( $x = 0; $x < 5; $x++ ) {

                $src = wp_get_attachment_image_src( $images_array[ $x ]->ID, 'full', false, '' );

                $link     = $src[0];
                $image_id = $images_array[ $x ]->ID;

                if ( $x === 0 ) {
                    $image_list .= '<div class="property-gallery__item property-gallery__item-main" data-image-id="' . $image_id . '"><a class="property-gallery__image-link" href="' . $link . '">' . wp_get_attachment_image( $image_id, 'wps_child_masonry_large', false, $image_args ) . '<div class="property-gallery_images-icon">' . $iconImages . '</div></a></div>';
                } elseif ( $x === 1 ) {
                    // Implement video link on second image
                    if(!empty($video) && empty($video_url) || !empty($video) && !empty($video_url)){
                        $image_list .= sprintf(
                            '<div class="property-gallery__item" data-image-id="' . $image_id . '"><a class="property-gallery__%s-link" href="%s"%s>%s%s</a>%s</div>',
                            $video ? 'video' : 'image',
                            $video ? $video : $link,
                            $video ? ' data-fancybox="video"' : ' data-fancybox="image"',
                            wp_get_attachment_image( $image_id, 'mapi_masonry_medium', false, $image_args ),
                            $video ? '<div class="property-gallery_video-icon">' . $iconPlay . '</div>' : '',
                            $video ? '<div class="property-gallery__image-link u-d-none"></div>' : ''
                        );
                    }
                    if(!empty($video_url) && empty($video) ){
                        $image_list .= sprintf(
                            '<div class="property-gallery__item" data-image-id="' . $image_id . '"><a class="property-gallery__%s-link" href="%s"%s>%s%s</a>%s</div>',
                            $video_url ? 'video' : 'image',
                            $video_url ? $video_url : $link,
                            $video_url ? ' data-fancybox="video"' : ' data-fancybox="image"',
                            wp_get_attachment_image( $image_id, 'mapi_masonry_medium', false, $image_args ),
                            $video_url ? '<div class="property-gallery_video-icon">' . $iconPlay . '</div>' : '',
                            $video_url ? '<div class="property-gallery__image-link u-d-none"></div>' : ''
                        );
                    }
                    if(empty($video_url) && empty($video)){
                        $image_list .= '<div class="property-gallery__item" data-image-id="' . $image_id . '"><a class="property-gallery__image-link" href="' . $link . '">' . wp_get_attachment_image( $image_id, 'mapi_masonry_medium', false, $image_args ) . '</a></div>';
                    }

                // }elseif($x === 2){
                    //show if 360 image is present
                }elseif($x === 3 && $floorplan){
                    $image_list .=  sprintf(
                        '<div class="property-gallery__item" data-image-id="' . $image_id . '"><a class="property-gallery__%s-link" href="%s"%s>' . wp_get_attachment_image( $image_id, 'mapi_masonry_medium', false, $image_args ) . '<div class="property-gallery_floorplan-icon">%s</div></a></div>',
                        $floorplan ? 'floorplan' : 'image',
                        $floorplan ? $floorplan : $link,
                        $floorplan ? 'data-fancybox="image"' : '',
                        $floorplan ? $iconFloorplan : ''
                    );
                }elseif($x === 4){
                    $image_list .= '<div class="property-gallery__item" data-image-id="' . $image_id . '"><a class="property-gallery__image-link" href="' . $link . '">' . wp_get_attachment_image( $image_id, 'mapi_masonry_medium', false, $image_args ) . '<span class="property-gallery_images-count">+' . $total .'</span></a></div>';
                } else {
                    $image_list .= '<div class="property-gallery__item" data-image-id="' . $image_id . '"><a class="property-gallery__image-link" href="' . $link . '">' . wp_get_attachment_image( $image_id, 'mapi_masonry_medium', false, $image_args ) . '</a></div>';
                }

            }

            // 360-degrees Button
            if ( $degrees_360 ) {
                $button .= sprintf(
                    '<div class="property-gallery__button-container"><div class="property-gallery__button property-gallery__button--360">%s</div></div>',
                    __( '360-degree', YSD_MAPI_TEXT_DOMAIN )
                );
            }

            // The Gallery
            $gallery = sprintf(
                '<div class="property-gallery"><div class="property-gallery__imagelist">%s</div><div class="property-gallery__button-wrapper">%s</div></div>',
                $image_list,
                $button
            );

            if ( $total >= 1 ) {
                // If we have media
                $output = $gallery;
            } else {
                // Image Placeholder
                $image_placeholder = YSD_MAPI_PLUGIN_URL . 'front/assets/src/images/image-placeholder.jpg';
                $image_alt = __( 'No Image', YSD_MAPI_TEXT_DOMAIN );
                $output = '<img class="property-gallery__no-image" src="' . $image_placeholder . '" alt="'. $image_alt .'" />';
            }

            $output = '<div class="property-gallery-wrapper">'. $output .'</div>';

            $templatera = get_option( 'ysd-mapi_single_template_hooks' );
            if ( 'disabled' != $templatera ) {
                echo $output;
            } else {
                return $output;
            }
        }
    }
}
new YSD_Mapi_Property_Gallery_Compact_Shortcode();