<?php

if ( ! class_exists( 'YSD_Mapi_Property_Gallery_Shortcode' ) ) {

    class YSD_Mapi_Property_Gallery_Shortcode {

        public function __construct() {
            add_shortcode( 'mapi_property_gallery', array( $this, 'mapi_property_gallery_shortcode' ) );
        }
        
        /*
        * Property Gallery
        */
        public static function mapi_property_gallery_shortcode($atts) {
            $atts = shortcode_atts(
                array(
                    'class'         => '',
                    'map'           => '',
                    'floorplan'     => '',
                    'brochure'      => '',
                    'print'         => '',
                    'favorite'      => '',
                    'share'         => ''
                ),
                $atts
            );

            $output = '';

            $post_id = get_queried_object_id();

            $images_args = array (
                'post_parent' => $post_id,
                'post_type' => 'attachment',
                'numberposts' => -1, // get all
                'post_status' => 'any',
                // 'post_mime_type' => 'image',
                'orderby' => 'date',
                'order' => 'ASC',
            );

            // Get attachments
            $images = get_posts( $images_args );
            $video_url = get_post_meta( $post_id, 'video_url', true );
            $videos = array();

            foreach ($images as $video){
                if($video->post_excerpt == 'SOURCE_PROPERTY_VIDEO'){
                    $video = $video->guid;
                    array_push($videos, $video);
                }
            }

            // Total Media
            $total = count( $images );
            // Declare variables
            $image_list         =   '';
            $button             =   '';
            $has_video          =   !empty($videos) ?? $videos;
            $has_video_url      =   !empty($video_url) ?? $video_url;
            $count              =   count( $images );
            // $show_map            =  get_option( 'ysd-mapi_single_show_map' );
            $degrees_360        =   0;
            $videos_count       =   count($videos);
            $video_url_count    =   $video_url ? 1 : 0;
	        $images_array       =   array_values( $images );
            $image_args         =   array( 'class' => 'property-gallery__image' );

            for ( $x = 0; $x < 5; $x++ ) {

                $src = wp_get_attachment_image_src( $images_array[ $x ]->ID, 'full', false, '' );

                $link     = $src[0];
                $image_id = $images_array[ $x ]->ID;

                if ( $x === 0 ) {
                    $image_list .= '<div class="property-gallery__item property-gallery__item-main" data-image-id="' . $image_id . '"><a class="property-gallery__image-link" href="' . $link . '">' . wp_get_attachment_image( $image_id, 'wps_child_masonry_large', false, $image_args ) . '</a></div>';
                }else {
                    $image_list .= '<div class="property-gallery__item" data-image-id="' . $image_id . '"><a class="property-gallery__image-link" href="' . $link . '">' . wp_get_attachment_image( $image_id, 'mapi_masonry_medium', false, $image_args ) . '</a></div>';
                }

            }

            // Images Button
            if ( $count > 1 ) {
                $button .= sprintf(
                    '<div class="property-gallery__button-container"><div id="property-gallery__trigger" class="property-gallery__button property-gallery__button--camera">%s <span class="property-gallery__button-count">%s</span></div></div>',
                    __( 'Photos', YSD_MAPI_TEXT_DOMAIN ),
                    $count
                );
            }

            // Videos Button
            if ( $has_video || $has_video_url ) {
                if(!empty($has_video) && empty($has_video_url) ){
                    $button .= sprintf(
                        // '<div class="property-gallery__button-container"><div id="property-gallery__videos" class="property-gallery__button property-gallery__button--video">%s <span class="property-gallery__button-count">%s</span></div></div>',
                        // __( 'Videos', YSD_MAPI_TEXT_DOMAIN ),
                        // $videos_count
                        '<div class="property-gallery__button-container"><div id="property-gallery__videos" class="property-gallery__button property-gallery__button--video">%s<a class="property-gallery__%s-link" href="%s"%s></a><span class="property-gallery__button-count">%s</span></div></div>',
                        __( 'Videos', YSD_MAPI_TEXT_DOMAIN ),
                        $video ? 'video' : 'image',
                        $video ? $video : $link,
                        $video ? ' data-fancybox="video"' : ' data-fancybox="image"',
                        $videos_count
                    );
                }
                if (!empty($has_video_url) && empty($has_video) ){
                    $button .= sprintf(
                        // '<div class="property-gallery__button-container"><div id="property-gallery__videos" class="property-gallery__button property-gallery__button--video">%s <span class="property-gallery__button-count">%s</span></div></div>',
                        // __( 'Videos', YSD_MAPI_TEXT_DOMAIN ),
                        // $videos_count
                        '<div class="property-gallery__button-container"><div id="property-gallery__videos" class="property-gallery__button property-gallery__button--video">%s<a class="property-gallery__%s-link" href="%s"%s></a><span class="property-gallery__button-count">%s</span></div></div>',
                        __( 'Videos', YSD_MAPI_TEXT_DOMAIN ),
                        $has_video ? 'video' : 'image',
                        $has_video ? $has_video : $link,
                        $has_video ? ' data-fancybox="video"' : ' data-fancybox="image"',
                        $video_url_count
                    ); 
                }

            }

            // 360-degrees Button
            if ( $degrees_360 ) {
                $button .= sprintf(
                    '<div class="property-gallery__button-container"><div class="property-gallery__button property-gallery__button--360">%s</div></div>',
                    __( '360-degree', YSD_MAPI_TEXT_DOMAIN )
                );
            }
            
            if($atts['floorplan'] == 'true'){
                ob_start();
                $button .= ob_get_clean();
                $button .= do_shortcode("[mapi_floorplan_link]");
                ob_get_contents();
            }
            if($atts['map'] == 'true'){
                ob_start();
                $button .= ob_get_clean();
                $button .= do_shortcode("[mapi_map_link]");
                ob_get_contents();
            }
            if($atts['brochure'] == 'true'){
                ob_start();
                $button .= ob_get_clean();
                $button .= do_shortcode("[mapi_brochure]"); 
                ob_get_contents();    
            }
            if($atts['print'] == 'true'){
                ob_start();
                $button .= ob_get_clean();
                $button .= do_shortcode("[mapi_print]"); 
                ob_get_contents();   
            }
            if($atts['favorite'] == 'true'){
                ob_start();
                $button .= ob_get_clean();
                $button .= do_shortcode("[mapi_favorite]");  
                ob_get_contents();
            }
            if($atts['share'] == 'true'){
                ob_start();
                $button .= ob_get_clean();
                $button .= do_shortcode("[mapi_share]");
                ob_get_contents();  
            }

            // The Gallery
            $gallery = sprintf(
                '<div class="property-gallery"><div class="property-gallery__imagelist">%s</div><div class="property-gallery__button-wrapper">%s</div></div>',
                $image_list,
                $button
            );

            if ( $total >= 1 ) {
                // If we have media
                $output = $gallery;
            } else {
                // Image Placeholder
                $image_placeholder = YSD_MAPI_PLUGIN_URL . 'front/assets/src/images/image-placeholder.jpg';
                $image_alt = __( 'No Image', YSD_MAPI_TEXT_DOMAIN );
                $output = '<img class="property-gallery__no-image" src="' . $image_placeholder . '" alt="'. $image_alt .'" />';
            }

            $output = '<div class="property-gallery-wrapper">'. $output .'</div>';

            $templatera = get_option( 'ysd-mapi_single_template_hooks' );
            if ( 'disabled' != $templatera ) {
                echo $output;
            } else {
                return $output;
            }

        }

    }

}
new YSD_Mapi_Property_Gallery_Shortcode();