<?php

if ( ! class_exists( 'YSD_Mapi_Property_Header_Shortcode' ) ) {

    class YSD_Mapi_Property_Header_Shortcode {

        public function __construct() {
            add_shortcode( 'mapi_property_header', array( $this, 'mapi_property_header_shortcode' ) );
        }
        
        /*
        * Property Header
        */
        public static function mapi_property_header_shortcode($atts) {
            $options = shortcode_atts(
                array(
                    'class'         => '',
                ),
                $atts
            );

            $post_id = get_queried_object_id();
            $property = get_post( $post_id );

            // Price type
            $fallback = __( 'Price', YSD_MAPI_TEXT_DOMAIN );
            $price_type = getPropertyPriceType( $property );
            $price_type = ($price_type['value']) ? $price_type['value'] : $fallback;
            
            // Price (Formatted/Locale)
            $price = getFormattedLocalePrice( $property );
            $price = (!empty($price)) ? $price : '';
            
            // Sale Condition
            $sale_condition = getPropertySaleCondition( $property );
            $sale_condition = (!empty($sale_condition)) ? $sale_condition : '';

            // Title
            $title = sprintf(
                '<div class="entry-title__city">%1$s</div><div class="entry-title__address">%2$s %3$s%4$s</div>',
                $property->city,
                $property->address_1,
                $property->house_number,
                $property->house_number_addition
            );
            
            // Price Label
            $price_label_output = sprintf(
                '<div class="property-header__price-label">%1$s</div>',
                $price_type
            );

            // Price
            $price_output = sprintf(
                '<div class="property-header__price">%1$s %2$s</div>',
                $price,
                $sale_condition
            );

            // Output
            $output = '';
            $output .= '<div class="property-header">';
                $output .= '<h2 class="entry-title">' . $title . '</h2>';
                $output .= '<div class="property-header__utility">';
                    $output .= $price_label_output . $price_output;
                $output .= '</div>';
            $output .= '</div>';

            $templatera = get_option( 'ysd-mapi_single_template_hooks' );
            if ( 'disabled' != $templatera ) {
                echo $output;
            } else {
                return $output;
            }

        }

    }

}
new YSD_Mapi_Property_Header_Shortcode();