<?php

if ( ! class_exists( 'YSD_Mapi_Property_Map_Shortcode' ) ) {
    class YSD_Mapi_Property_Map_Shortcode {

        public function __construct() {
            add_shortcode( 'mapi_property_map', array( $this, 'mapi_property_map_shortcode' ) );
        }

        public static function mapi_property_map_shortcode( $atts ) {
            $options = shortcode_atts(
                array(
                    'post_id' => '',
                    'title' => '',
                    'class' => '',
                    'all_houses' => false,
                ),
                $atts,
                'mapi_property_map'
            );
            
            $output   = '';

            $post_id  = $options['post_id'] ? $options['post_id'] : get_queried_object_id();
            $property = $post_id ? get_post($post_id) : '';

            $propertyData = $fullAddress ='';

            if ($property) {
                $propAddr = $property->address_1 ? $property->address_1 : '';
                $propNumb = $property->house_number ? $property->house_number : '';
                $propCity = $property->city ? $property->city : '';
                
                $fullAddress = ($propAddr && $propNumb && $propCity) ? $propAddr .' '. $propNumb .', '. $propCity : '';
                
                $propertyData = array(
                    'address' => $propAddr,
                    'number' => $propNumb,
                    'city' => $propCity,
                );
            } else {
                return; // Cancel this whole Component!
            }

            // Leaflet Map
            wp_enqueue_style( 'leaflet-map-style', 'https://unpkg.com/leaflet@1.7.1/dist/leaflet.css', array(), false, 'all'  );
            wp_enqueue_script( 'leaflet-map-script', 'https://unpkg.com/leaflet@1.7.1/dist/leaflet.js', array('jquery') );

            // Leaflet GeoSearch
            wp_enqueue_style( 'leaflet-search-style', 'https://unpkg.com/leaflet-geosearch@2.6.0/assets/css/leaflet.css', array(), false, 'all'  );
            wp_enqueue_script( 'leaflet-search-script', 'https://unpkg.com/leaflet-geosearch@2.6.0/dist/bundle.min.js', array('jquery') );

            // Property Map
            wp_register_script( 'property-map-script', YSD_MAPI_PLUGIN_URL . 'front/assets/src/js/shortcodes/property-map.js', array( 'jquery' ), false, true );

            $map_data = array(
                'property' => $propertyData,
                'markerContent' => $fullAddress
            );
            
            if($options['all_houses'] == true){
                // echo "<script>console.log('propCity: " . json_encode($propCity) . "');</script>";
                $args = array(
                    'post_type'      => 'property',
                    'posts_per_page' => -1,
                );
                
                $post_list = get_posts( $args );
                $city_arr = array();
                foreach($post_list as $list){
                    setup_postdata( $list );
                    $post = get_post( $list->ID );
                    $full_address = $post->post_title;
                    if(explode(', ', $full_address)[1] == $propCity && explode(', ', $full_address)[0] != $propAddr .' '. $propNumb){
                        // echo "<script>console.log('full_address: " . json_encode($full_address) . "');</script>";
                        
                        // $address_parts = explode(' ', $full_address);
                        // $propAddr = $address_parts[0];
                        // $propNumb = explode(',',$address_parts[1])[0];
                        // $propCity = $address_parts[2];
                        // $propertyData = array(
                        //     'address' => $propAddr,
                        //     'number' => $propNumb,
                        //     'city' => $propCity,
                        // );

                        // $all_houses = array(
                        //     'propertyAll' => $propertyData,
                        //     'markerContentAll' => $full_address
                        // );
                        $all_houses = array(
                            'propertyAll' => $full_address,
                        );

                        array_push($city_arr, $all_houses);
                    }
                }

                wp_localize_script( 'property-map-script', 'mapDataAll', $city_arr );

            }else{
                wp_localize_script( 'property-map-script', 'mapDataAll', '' );
            }
            
            wp_localize_script( 'property-map-script', 'mapData', $map_data );
            wp_enqueue_script( 'property-map-script' );
            // echo "<script>console.log('map_data: " . json_encode($map_data) . "');</script>";
            // echo "<script>console.log('city_arr: " . json_encode($city_arr) . "');</script>";


            // Add custom class
            $customCss  = $options['class'] ? ' ' . $options['class'] : '';

            // Wrap all output
            $output = '<div id="propertyMap" class="c-property-map'. $customCss .'" style="min-height: 500px;">'. $output .'</div>';


            $templatera = get_option( 'ysd-mapi_single_template_hooks' );
            if ( 'disabled' != $templatera ) {
                echo $output;
            } else {
                return $output;
            }

        }

        public static function mapi_property_map_shortcode_add() {

            $output = '';

            $output .= '<div class="c-no-container">';
                $output .= '<div class="c-row">';
                    $output .= '<div class="c-col">';
                        ob_start();
                        $output .= do_shortcode( '[mapi_property_map]' );
                        $output .= ob_get_clean();
                        ob_get_contents();
                    $output .= '</div>';
                $output .= '</div>';
            $output .= '</div>';

            echo $output;

        }
        
    }

}
new YSD_Mapi_Property_Map_Shortcode();