<?php

/**
 * Shortcode:
 * Property Archive Footer
 */
if ( !function_exists( 'mapi_shortcode_property_archive_footer' ) ) {
    function mapi_shortcode_property_archive_footer( $atts ) {
        $options = shortcode_atts(
            array(
                'class' => '',
            ),
            $atts,
            'property_archive_footer'
        );

        ob_start();
        $output = '';

        // Add custom class
        $customCss = $options['class'] ? ' ' . $options['class'] : '';
        ?>

        <div class="property-loop-footer<?php echo $customCss; ?>">
            <?php
            // Property Query
            if ( class_exists( 'Mapi_Property_Query' ) ) {
                $custom_query = Mapi_Property_Query::init();
            }

            // Property Query Pagination
            if ( class_exists( 'Mapi_Property_Pagination' ) ) {
                $pagination = new Mapi_Property_Pagination( $custom_query->max_num_pages );
                $pagination->property_pagination();
            }
            ?>
        </div>

        <?php
        $output = ob_get_contents();
        ob_end_clean();
        return $output;

    }
}
add_shortcode( 'property_archive_footer', 'mapi_shortcode_property_archive_footer' );