<?php

/**
 * Shortcode:
 * Property Archive Header
 */
if ( !function_exists( 'mapi_shortcode_property_archive_header' ) ) {
    function mapi_shortcode_property_archive_header( $atts ) {
        $options = shortcode_atts(
            array(
                'class' => '',
            ),
            $atts,
            'property_archive_header'
        );

        ob_start();
        $output = '';

        // Add custom class
        $customCss = $options['class'] ? ' ' . $options['class'] : '';
        ?>

        <div class="property-loop-header<?php echo $customCss; ?>">
            <?php
                $archive_display_title = get_option( 'ysd-mapi_archive_display_title', true );
                if ( $archive_display_title ) {
                    echo sprintf(
                        '<h1 class="mapi-title">%1$s</h1>',
                        __('Our Properties', YSD_MAPI_TEXT_DOMAIN),
                    );
                }
            ?>
            <div id="propertyFilterSettings" class="property-filter-settings">
                <div class="filter-setting-top">
                    
                    <?php if ( class_exists('Mapi_Property_Filter_Result_Count') ) : ?>
                        <div class="filter-setting__item filter-setting__item--Filter_Result_Count"><?php new Mapi_Property_Filter_Result_Count(); ?></div>
                    <?php endif; ?>

                    <?php if ( class_exists('Mapi_Property_Posts_Per_page') ) : ?>
                        <div class="filter-setting__item filter-setting__item--Posts_Per_page"><?php new Mapi_Property_Posts_Per_page(); ?></div>
                    <?php endif; ?>
                    
                    <?php if ( class_exists('Mapi_Property_Orderby') ) : ?>
                        <div class="filter-setting__item filter-setting__item--Orderby"><?php new Mapi_Property_Orderby(); ?></div>
                    <?php endif; ?>
                    
                    <?php if ( class_exists('Mapi_Property_Layout_Toggle') ) : ?>
                        <div class="filter-setting__item filter-setting__item--Layout_Toggle"><?php new Mapi_Property_Layout_Toggle(); ?></div>
                    <?php endif; ?>

                </div>
                <div class="filter-setting-bottom">

                    <?php if ( class_exists('Mapi_Property_Filter_Values') ) : ?>
                        <div class="filter-setting__item filter-setting__item--Filter_Values"><?php new Mapi_Property_Filter_Values(); ?></div>
                    <?php endif; ?>

                    <?php if ( class_exists('Mapi_Property_Filter_Toggle') ) : ?>
                        <div class="filter-setting__item filter-setting__item--Filter_Toggle"><?php new Mapi_Property_Filter_Toggle(); ?></div>
                    <?php endif; ?>
                    
                </div>
            </div>
        </div>

        <?php
        $output = ob_get_contents();
        ob_end_clean();
        return $output;

    }
}
add_shortcode( 'property_archive_header', 'mapi_shortcode_property_archive_header' );