<?php

/**
 * Shortcode:
 * Property Archive Loop
 */
if ( !function_exists( 'mapi_shortcode_property_archive_loop' ) ) {
    function mapi_shortcode_property_archive_loop( $atts ) {
        $options = shortcode_atts(
            array(
                'class' => '',
            ),
            $atts,
            'property_archive_loop'
        );

        ob_start();
        $output = '';

        // Add custom class
        $customCss = $options['class'] ? ' ' . $options['class'] : '';
        ?>

        <div class="property-loop-content<?php echo $customCss; ?>">
            <?php
                
                if ( class_exists( 'Mapi_Property_Query' ) ) {
                    $custom_query = Mapi_Property_Query::init();
                }

                // Loop Query
                if ($custom_query->have_posts()) {
                ?>
                    <div id="properties" class="c-properties <?php echo mapi_get_properties_per_row(); ?> <?php echo mapi_get_property_layout($_COOKIE, 'display'); ?>">
                    <?php
                        if ( class_exists( 'Mapi_Property_Template' ) ) {
                            $property = new Mapi_Property_Template();

                            while ( $custom_query->have_posts() ) {
                                $custom_query->the_post();

                                $args = array(
                                    'post_id'       =>  get_the_ID(),
                                );

                                $property->setArgs( $args );

                                echo $property->render();

                            }

                        }
                    ?>
                    </div>
                    <?php

                    // Reset postdata
                    wp_reset_postdata();
                } else {
                    do_action( 'mapi_no_properties_found' );
                }
            ?>
        </div>

        <?php
        $output = ob_get_contents();
        ob_end_clean();
        return $output;

    }
}
add_shortcode( 'property_archive_loop', 'mapi_shortcode_property_archive_loop' );