<?php

/**
 * Shortcode:
 * Property Archive Search
 */
if ( !function_exists( 'mapi_shortcode_property_archive_search' ) ) {
    function mapi_shortcode_property_archive_search( $atts ) {
        $options = shortcode_atts(
            array(
                'class' => 'u-d-flex u-d-lg-none u-align-items-center',
            ),
            $atts,
            'property_archive_search'
        );

        ob_start();
        $output = '';

        // Add custom class
        $customCss = $options['class'] ? ' ' . $options['class'] : '';
        ?>
        
        <section class="mapi-sidebar-area__header<?php echo $customCss; ?>">
            <h3 class="mapi-sidebar-area__title"><?php _e('Filters', YSD_MAPI_TEXT_DOMAIN); ?></h3>
            <button id="closeMapiSidebar" class="close-mapi-sidebar" type="button">
                <span class="close-mapi-sidebar-icon" style="background-image: none;"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 48"><path d="M26.12 24l10.61-10.61a1.5 1.5 0 000-2.12 1.5 1.5 0 00-2.12 0L24 21.88 13.39 11.27a1.5 1.5 0 10-2.12 2.12L21.88 24 11.27 34.61a1.5 1.5 0 102.12 2.12L24 26.12l10.61 10.61a1.5 1.5 0 002.12 0 1.5 1.5 0 000-2.12z" fill="currentColor"></path></svg></span>
            </button>
        </section>

        <?php 
            $is_auto_submit = get_option( 'ysd-mapi_archive_filter_auto_submit', true );
            $filterAutoSubmit = ( true == $is_auto_submit ) ? ' mapi-filter--auto-submit' : '';
        ?>

        <?php if ( function_exists( 'get_mapi_property_filters' ) ) { ?>
            <section class="mapi-sidebar-area__filter c-widget u-background-color-white u-p-3">
                <form id="mapiFilterForm" class="mapi-filter<?php echo $filterAutoSubmit; ?>" method="GET" action="<?php echo get_post_type_archive_link( 'property' ); ?>">
                        
                    <?php
                        get_mapi_property_filters();

                        if ( true != $is_auto_submit ) {
                            $option = get_option( 'ysd-mapi_archive_filter_submit_class' );
                            $class = ! empty( $option ) ? 'class="'. $option .'"' : 'class="c-button c-button--color-1"';
                            ?><input type="submit" value="<?php _e('Submit', YSD_MAPI_TEXT_DOMAIN); ?>"<?php echo $class; ?>><?php
                        }
                    ?>

                </form>
            </section>
        <?php } ?>

        <?php
        $output = ob_get_contents();
        ob_end_clean();
        return $output;

    }
}
add_shortcode( 'property_archive_search', 'mapi_shortcode_property_archive_search' );