<?php
namespace ysdmapi\includes\custom_fields;

class FieldValidator
{
    /**
     * Validate a field by calling it's specified validation method
     *
     * @param CustomField $field
     * The field to validate
     * 
     * @param mixed $value
     * The value of the input
     * 
     * @return array
     */
    public static function validate_field($field, $value)
    {
        $results['valid'] = true;

        /* by default don't allow more than 200 characters in an input */
        $max_characters = $field->max_characters ?? 200;

        if(!empty($value))
        {
            if(strlen($value) > $max_characters)
            {
                $results['message'] = 'Max amount of characters exceeded';
                $results['valid'] = false;
            }
            else if(isset($field->validation))
            { 
                if(!call_user_func($field->validation, $value))
                {
                    $results['message'] = 'Invalid input';
                    $results['valid'] = false;
                }
            }
        }

        return $results;

    }

    public static function validate_dutch_zipcode($value)
    {
        return preg_match('/^([0-9]{4})[- ]?([A-z]{2})$/', $value);
    }

    public static function validate_city($value)
    {
        return preg_match('/^[A-z]+([\s-][A-z]+)*$/', $value);
    }
}