<?php
$field = $data['field'];
?>

<div class="mapi-default-field">
    <?php include YSD_MAPI_CUSTOM_FIELDS_COMPONENTS . '/label.php' ?>

    <select name="<?php echo $field->id . "[type]" ?>" id="<?php echo $field->id ?>" class="ysd-mapi-interval-select">
        <option hidden disabled value <?php echo !is_null($field->get_value("type")) ? 'selected' : '' ?>><?php echo ' '. __( '-- select an option --', YSD_MAPI_TEXT_DOMAIN ) .' '; ?></option>
        
        <?php if(array_key_exists('daily', $field->options)) : ?>
            <?php $selected = $field->get_value("type") == 'daily' ? 'selected' : ''; ?>
            <option <?php echo $selected ?> value="daily">
                <?php echo esc_html($field->options['daily']); ?>
            </option>
        <?php endif ?>

        <?php if(array_key_exists('hourly', $field->options)) : ?>
            <?php $selected = $field->get_value("type") == 'hourly' ? 'selected' : ''; ?>
            <option <?php echo $selected ?> value="hourly">
                <?php echo esc_html($field->options['hourly']); ?>
            </option>
        <?php endif ?>

        <?php if(array_key_exists('none', $field->options)) : ?>
            <?php $selected = $field->get_value("type") == 'none' ? 'selected' : ''; ?>
            <option <?php echo $selected ?> value="none">
                <?php echo esc_html($field->options['none']); ?>
            </option>
        <?php endif ?>
    </select>
</div>

<div class="ysd-mapi-interval-fields">
    <div class="daily">
        <label><?php _e( 'Time of day', YSD_MAPI_TEXT_DOMAIN ); ?></label>
        <input type="time" value="<?php echo $field->get_value("tod") ?>" name="<?php echo $field->id . "[tod]" ?>">
    </div>
    <div class="hourly">
        <label><?php _e( 'Hours', YSD_MAPI_TEXT_DOMAIN ); ?></label>
        <input type="number" value="<?php echo $field->get_value("hourly_interval") ?>" name="<?php echo $field->id . "[hourly_interval]" ?>" min="1">
    </div>
</div>
